<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;
$translator->addTranslation('navigation',CPO_BASEDIR.$moduleDirectory.'/lang');

if (!function_exists('tocHelp')) {
	function tocHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

$gallerybreak = true;
define('CPO_MOD_GALLERY',$dbPrefix."_mod_bilderalbum");

if (!function_exists('gdVersion'))  {

	function gdVersion($user_ver = 0)
	{
	 //  return 1;
	   if (! extension_loaded('gd')) { return; }
	   static $gd_ver = 0;
	   // Just accept the specified setting if it's 1.
	   if ($user_ver == 1) { $gd_ver = 1; return 1; }
	   // Use the static variable if function was called previously.
	   if ($user_ver !=2 && $gd_ver > 0 ) { return $gd_ver; }
	   // Use the gd_info() function if possible.
	   if (function_exists('gd_info')) {
		   $ver_info = gd_info();
		   preg_match('/\d/', $ver_info['GD Version'], $match);
		   $gd_ver = $match[0];
		   return $match[0];
	   }
	   // If phpinfo() is disabled use a specified / fail-safe choice...
	   if (preg_match('/phpinfo/', ini_get('disable_functions'))) {
		   if ($user_ver == 2) {
			   $gd_ver = 2;
			   return 2;
		   } else {
			   $gd_ver = 1;
			   return 1;
		   }
	   }
	   // ...otherwise use phpinfo().
	   ob_start();
	   phpinfo(8);
	   $info = ob_get_contents();
	   ob_end_clean();
	   $info = stristr($info, 'gd version');
	   preg_match('/\d/', $info, $match);
	   $gd_ver = $match[0];
	   return $match[0];
	} // End gdVersion()
}

if (gdVersion() < 2) $warn_install = __(' (There is no installed GD2 on your system found, so you will not be able to use the module. The install-function has been diasabled!)');

$GLOBALS['modules']['Bilderalbum'] = array(
	'directory'	=> $moduleDirectory,
	'caption'	=> __('Picture Gallery / Slideshow').$warn_install,
	'install'	=> (gdVersion() >= 2) ? 'function: Bilderalbum_install' : '',
    'activate'	=> (gdVersion() >= 2) ? 'function: Bilderalbum_activate' : '',
    'deactivate'=> (gdVersion() >= 2) ? 'function: Bilderalbum_deactivate' : '',
    'uninstall'	=> (gdVersion() >= 2) ? 'function: Bilderalbum_uninstall' : '',
    'manage'	=> (gdVersion() >= 2) ? 'function: Bilderalbum_manage' : '',
	'owner'		=> $cpoSystem['owner'],
	'lkey'		=> '',
	'mod_id'	=> 4,
	'rights'	=> array($_SESSION['SID_user']['id']=>'111'),
// HELP -------------------------------------------------------------------------------------
    'helptoc'	=> array(
        'bersicht' 
			=> tocHelp('index','gallery'),
        '1. Was macht das Modul "Bilderalbum"?' 
			=> tocHelp('features','gallery'),
        '2. Installation' 
			=> tocHelp('setup','gallery'),
        '3. Einstellungen' 
			=> tocHelp('settings','gallery'),
        '4. Anwendung' 
			=> tocHelp('application','gallery'),
		'5. Template-Platzhalter' 
			=> tocHelp('templates','gallery'),
		'6. Rechte' 
			=> tocHelp('rights','gallery')
    ),
	'externalHelpUrl'	=> 'http://manual.conpresso4.de',
// General settings -------------------------------------------------------------------------------------
    'quality'		=> 90,
	'max_width'		=> 600,
	'max_height'	=> 400,
	'min_size'		=> 600,
	'usage_message'	=> 'yes',
	'size_message'	=> 'yes',
	'overview_format'	=> 'table',
	'slideshow_format'	=> 'popup',
	'member_suffix'	=> '4members',
	'sorting'	    => 'name',
    'x_files'       => '',
// Table settings -------------------------------------------------------------------------------------
	'satzspiegel'	=> 600,
	'album_rows'	=> 3,
	'default_cols'	=> 4,
	'slide_frame'	=> 8,
	'padding'		=> 5,
	'slide_template'=>'<td class="slide">
  <table><tr><td class="ol"></td><td class="om"></td><td class="or"></td></tr>
    <tr><td class="ml"></td>
      <td class="mm"><a href="../### ALBUM_DIR ###/popup.php?pic=### ALBUM_PIC ###&from=### ALBUM_FROM ###" onclick="slidePage(### ARTICLE_NR ###, \'### ALBUM_PIC ###\', \'### ALBUM_FROM ###\'); return false;"><img src="../### ALBUM_DIR ###/bilder/### ALBUM_THUMB ###" alt="### ALBUM_PIC_DESCRIPTION ###"></a></td>
    <td class="mr"></td></tr>
    <tr><td class="ul"></td><td class="um"></td><td class="ur"></td></tr>
  </table>
</td>',
	'lightbox_slide_template'=>'<td class="slide">
  <table><tr><td class="ol"></td><td class="om"></td><td class="or"></td></tr>
    <tr><td class="ml"></td>
      <td class="mm"><a href="../### ALBUM_DIR ###/bilder/h### ALBUM_PIC ###" title="### ALBUM_PIC_DESCRIPTION ###" rel="lightbox[### ALBUM_FROM ###]"><img src="../### ALBUM_DIR ###/bilder/### ALBUM_THUMB ###" alt="### ALBUM_PIC_DESCRIPTION ###"></a></td>
    <td class="mr"></td></tr>
    <tr><td class="ul"></td><td class="um"></td><td class="ur"></td></tr>
  </table>
</td>',
// DIV settings -------------------------------------------------------------------------------------
	'image_size'	=> 130,
	'num_images'	=> 12,
	'thumb_template'=> '<div style="float: left; border: 1px solid black; margin: 0px 5px 5px 0px; background: url(../### ALBUM_DIR ###/bilder/### ALBUM_THUMB ###) no-repeat 50% 50%;"><a style="display: block; width:143px; height:143px;" href="../### ALBUM_DIR ###/popup.php?pic=### ALBUM_PIC ###&from=### ALBUM_FROM ###" onclick="slidePage(### ARTICLE_NR ###, \'### ALBUM_PIC ###\', \'### ALBUM_FROM ###\'); return false;"></a></div>',
	'lightbox_thumb_template'=> '<div style="float: left; border: 1px solid black; margin: 0px 5px 5px 0px; background: url(../### ALBUM_DIR ###/bilder/### ALBUM_THUMB ###) no-repeat 50% 50%;"><a style="display: block; width:143px; height:143px;" href="../### ALBUM_DIR ###/bilder/h### ALBUM_PIC ###" title="### ALBUM_PIC_DESCRIPTION ###" rel="lightbox[### ALBUM_FROM ###]"></a></div>',
// Pop-Up settings -------------------------------------------------------------------------------------
	'pop_up_width'	=> 600,
	'pop_up_height'	=> 450,
	'show_template'=>'<!DOCTYPE html>
<html>
  <head>
    <title>Bilderalbum: ### ALBUM_TITLE ###</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-15">
    <script type="text/javascript" src="../mod_gallery/js/jquery-1.9.1.min.js"></script>
    <script type="text/javascript" src="../mod_gallery/js/jquery-migrate-1.1.1.min.js"></script>
    <script type="text/javascript" src="../mod_gallery/js/fadeslideshow.js">
    /***********************************************
    * Ultimate Fade In Slideshow v2.0- (c) Dynamic Drive DHTML code library (www.dynamicdrive.com)
    * This notice MUST stay intact for legal use
    * Visit Dynamic Drive at http://www.dynamicdrive.com/ for this script and 100s more
    ***********************************************/
    </script>
    <script type="text/javascript" src="../mod_gallery/js/extrabuttons.js"></script>
    <script type="text/javascript">
    var mygallery=new fadeSlideShow({
        wrapperid: "slideshow### ARTICLE_NR ###", //ID of blank DIV on page to house Slideshow
        dimensions: [### MAX_WIDTH ###, ### MAX_HEIGHT ###], //width/height of gallery in pixels. Should reflect dimensions of largest image
        imagearray: [ ### ALBUM_FADE_SHOW ### ],
        displaymode: {type:\'auto\', pause:5000, cycles:0, wraparound:true},
        persist: false, //remember last viewed slide and recall within same session?
        fadeduration: 1000, //transition duration (milliseconds)
        descreveal: "peekaboo",
        extrabuttons: {pend: \'.bob\', nextprevresume: false, navfade: 0.65, navbutonly: true, pause: 1000},
        startindex: ### ALBUM_FADE_SHOW_INDEX ###, //Zero based starting index
        togglerid: "slideshowtoggler### ARTIKLE_ID ###"
    })
    </script>
    <link rel="stylesheet" type="text/css" href="../_cfg/style.css.dist" />
<style>
body { margin:0;padding:0; }
#slideshow### ARTICLE_NR ###, #slideshow### ARTICLE_NR ### .gallerylayer {
    background-color: white !important;
    cursor: url(../mod_gallery/pics/pause2.ico), wait;
}
#slideshow### ARTICLE_NR ### a img {
    cursor: url(../mod_gallery/pics/zoom_in.ico), wait;
}
#slideshowtoggler### ARTICLE_NR ### {
    margin: 10px auto;
    text-align: center;
}
#slideshowtoggler### ARTICLE_NR ### img {
    border: 0;
    vertical-align: middle;
}

div.descpanelfg {
    color: black !important;
    text-align: center;
    font-size: 14px;
    padding: 8px !important;
    width:600px !important;
    left: 50% !important;
    margin-left: -300px !important;
}
div.descpanelbg {
    background-color: white !important;
    width:600px !important;
    left: 50% !important;
    margin-left: -300px !important;
}
span.status {
    font-weight: bold;
    padding: 0 20px;
}
</style>
    <link rel="stylesheet" type="text/css" href="../_cfg/style.css">
  </head>
<body>
<div id="slideshow### ARTICLE_NR ###"></div>
<div id="slideshowtoggler### ARTICLE_NR ###">
    <a href="#" class="prev" title="Vorheriges Bild"><img src="../mod_gallery/pics/left.png" /></a>
    <a href="#" class="pauseplay running" title="Pause"><img src="../mod_gallery/pics/pause.png" /></a>
    <span style="display:none;"><a href="#" class="pauseplay paused" title="Abspielen"><img src="../mod_gallery/pics/play.png" /></a></span>
    <span class="status"></span>
    <a href="#" class="next" title="Nchstes Bild"><img src="../mod_gallery/pics/right.png" /></a>
</div>
</body>
</html>',
	'inpage_template'=> '<!-- Start InPage Slideshow ***************************************** -->
    <!-- if not working check if jquery is loaded in the page header! -->
    <script type="text/javascript" src="../mod_gallery/js/fadeslideshow.js">
    /***********************************************
    * Ultimate Fade In Slideshow v2.0- (c) Dynamic Drive DHTML code library (www.dynamicdrive.com)
    * This notice MUST stay intact for legal use
    * Visit Dynamic Drive at http://www.dynamicdrive.com/ for this script and 100s more
    ***********************************************/
    </script>
    <script type="text/javascript" src="../mod_gallery/js/extrabuttons.js"></script>
    <script type="text/javascript">
    var mygallery=new fadeSlideShow({
        wrapperid: "slideshow### ARTICLE_NR ###",
        dimensions: [### MAX_WIDTH ###, ### MAX_HEIGHT ###],
        imagearray: [ ### ALBUM_FADE_SHOW ### ],
        displaymode: {type:\'auto\', pause:5000, cycles:0, wraparound:true},
        persist: false,
        fadeduration: 1000,
        descreveal: "peekaboo",
        extrabuttons: {pend: \'.bob\', nextprevresume: false, navfade: 0.65, navbutonly: true, pause: 1000},
        startindex: ### ALBUM_FADE_SHOW_INDEX ###,
        togglerid: "slideshowtoggler### ARTIKLE_ID ###"
    })
    </script>
<style>
body { margin:0;padding:0; }
#slideshow### ARTICLE_NR ###, #slideshow### ARTICLE_NR ### .gallerylayer {
    background-color: white !important;
    cursor: url(../mod_gallery/pics/pause2.ico), wait;
}
#slideshow### ARTICLE_NR ### a img {
    cursor: url(../mod_gallery/pics/zoom_in.ico), wait;
}
#slideshowtoggler### ARTICLE_NR ### {
    margin: 10px auto;
    text-align: center;
}
#slideshowtoggler### ARTICLE_NR ### img {
    border: 0;
    vertical-align: middle;
}

div.descpanelfg {
    color: black !important;
    text-align: center;
    font-size: 14px;
    padding: 8px !important;
    width:600px !important;
    left: 50% !important;
    margin-left: -300px !important;
}
div.descpanelbg {
    background-color: white !important;
    width:600px !important;
    left: 50% !important;
    margin-left: -300px !important;
}
span.status {
    font-weight: bold;
    padding: 0 20px;
}
</style>
<div id="slideshow### ARTICLE_NR ###"></div>
<div id="slideshowtoggler### ARTICLE_NR ###">
    <a href="#" class="prev" title="Vorheriges Bild"><img src="../mod_gallery/pics/left.png" /></a>
    <a href="#" class="pauseplay running" title="Pause"><img src="../mod_gallery/pics/pause.png" /></a>
    <span style="display:none;"><a href="#" class="pauseplay paused" title="Abspielen"><img src="../mod_gallery/pics/play.png" /></a></span>
    <span class="status"></span>
    <a href="#" class="next" title="Nchstes Bild"><img src="../mod_gallery/pics/right.png" /></a>
</div>
<!-- End InPage Slideshow ***************************************** -->',
	'link_original' => 'yes',
// PRO Options -----------------------------------------------------------------------------------------
	'staggered_num'             => 3,
	'mark_copyright'            => 'no',
	'copyright_pos'	            => 9,
	'copyright_content'	        => ''.date('Y').' by '.$cpoSystem['project'],
	'copyright_border'	        => 5,
	'text_color'	            => '#FFFFFF',
	'shadow_color'	            => '#000000',
	'font'	                    => 'fonts/FreeSansBold.ttf',
	'font_size'	                => 12,
	'show_watermark'            => 'no',
	'watermark_pos'             => 5,
	'watermark_pic'             => 'watermark/conpresso_logo.jpg',
	'watermark_scale'           => 'no',
	'watermark_transparency'    => 30,
	'watermark_mode'            => 'color',
// Overview gallery -------------------------------------------------------------------------------------
	'page_rewind'        => '',
	'page_forward'       => '',
	'pagination'         => '[<a href="### PAGE_LINK ###">### PAGE ###</a>]',
	'actual_page'        => '&nbsp;<b>### PAGE ###</b>&nbsp;',
	'album_navigation'   => '### PAGE_REWIND ### '.__('pages').' ### PAGINATION ### ### PAGE_FORWARD ###',
	'display_navigation' => 'auto',
    'album_css'          => "<style>
#gallery### ARTICLE_NR ### table { width:600px; border: none; border-collapse: collapse; }
#gallery### ARTICLE_NR ### td.slide { text-align:center !important; vertical-align:middle !important; width:### SLIDE_SIZE ###px; height:### SLIDE_SIZE ###px; }
#gallery### ARTICLE_NR ### td.slide table { width:### SLIDE_SIZE ###px; height:### SLIDE_SIZE ###px; border: none; border-collapse: collapse; }
#gallery### ARTICLE_NR ### td.slide table td { padding: 0px; }
#gallery### ARTICLE_NR ### td.ol { width:8px; height:8px; background-image: url('../mod_gallery/slides/frame_1a.gif'); }
#gallery### ARTICLE_NR ### td.om { height:8px; background-image: url('../mod_gallery/slides/frame_1b.gif'); }
#gallery### ARTICLE_NR ### td.or { width:8px; height:8px; background-image: url('../mod_gallery/slides/frame_1c.gif'); }
#gallery### ARTICLE_NR ### td.ml { width:8px; background-image: url('../mod_gallery/slides/frame_2a.gif'); }
#gallery### ARTICLE_NR ### td.mm { text-align:center !important; vertical-align:middle !important; width:### INNER_SLIDE_SIZE ###px; height:### INNER_SLIDE_SIZE ###px; background-image: url('../mod_gallery/slides/frame_2b.gif'); }
#gallery### ARTICLE_NR ### td.mr { width:8px; background-image: url('../mod_gallery/slides/frame_2c.gif'); }
#gallery### ARTICLE_NR ### td.ul { width:8px; height:8px; background-image: url('../mod_gallery/slides/frame_3a.gif'); }
#gallery### ARTICLE_NR ### td.um { height:8px; background-image: url('../mod_gallery/slides/frame_3b.gif'); }
#gallery### ARTICLE_NR ### td.ur { width:8px; height:8px; background-image: url('../mod_gallery/slides/frame_3c.gif'); }
#gallery### ARTICLE_NR ### td.mm img { border: none; }
</style>",
	'album_template'=> '<div id="gallery### ARTICLE_NR ###"><div id="### ALBUM_ANCHOR ###"></div>
<!-- ********** Start Album ********* -->
<!-- ********** Start Beschreibung ********* -->
<div style="text-align:center;">### ALBUM_DESCRIPTION ###</div>
<!-- ********** Ende Beschreibung ********* -->
<!-- ********** Start Dia-Tabelle / Miniaturen ********* -->
### SLIDE_TABLE ###
<!-- ********** Ende Dia-Tabelle / Miniaturen  ********* -->
<br clear="all" />
<!-- ********** Start Album-Navigation ********* -->
<div style="text-align:center;">### ALBUM_NAVIGATION ###</div>
<!-- ********** Ende Album-Navigation ********* -->
<!-- ********** Ende Album ********* -->
</div>',
	'go_to_text'=> __('Go to the Slideshow '),
	'go_back_text'=> '<br clear="all" /><div style="text-align:center;"><a href="#" onClick="closeSlidePage(### ARTICLE_NR ###); return false;">'.__('back to overview').'</a></div>',
// System settings -------------------------------------------------------------------------------------
	'menu'			=> 'main',
// Random gallery settings -------------------------------------------------------------------------------------
	'random_gallery_link'			=> 'image',
	'linktoimage_string'			=> '<a href="%1$s/bilder/h%2$s" onclick="ZoomImageFenster(this.href,%3$s,%4$s,\'Anklicken zum Schlieen des Fensters / Click to close this window\'); return false" title="Anklicken zum Vergrern / Click to enlarge %9$s %5$s" target="_blank"><img src="%1$s/bilder/t%2$s" border="0" alt="%9$s %5$s"></a>',
	'linktoalbum_string'			=> '<a href="%1$s/album.php?pic=%2$s&from=%6$s" title="%9$s %5$s" target="_blank" onclick="window.open(this.href,\'Bilderalbum\',\'width=%7$s,height=%8$s,scrollbars=no\'); return false;"><img src="%1$s/bilder/t%2$s" border="0" alt="%9$s %5$s"></a>'

);

// Hier kommen die Basis-Funktionen ***************************************************************

if (!function_exists('log_gallery')) {
	function log_gallery()
	{
		global $cpoSystem;
		@mail('kontakt@conpresso4.de','Das Modul Bilderalbum 4.3b wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
	}
}

function Bilderalbum_install()
{
	global $dbPrefix, $db;
	include (CPO_BASEDIR.$GLOBALS['modules']['Bilderalbum']['directory'].'/includes/setup.inc.php');
	log_gallery();
	$gallerydb = new DB;
	$gallerydb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('gallery', '".serialize(array("installed"=>time()))."', '') ");
}

function Bilderalbum_activate()
{
	// Navigation reloaden in frame "cpo_navigation"
	$reload_navigation = "<script type=\"text/javascript\">";
	$reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
	$reload_navigation .= "</script>";

    $GLOBALS['message'][] = __('The gallery-module got activated.').$reload_navigation;
}

function Bilderalbum_deactivate()
{
	$reload_navigation = "<script type=\"text/javascript\">";
	$reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
	$reload_navigation .= "</script>";

    $GLOBALS['message'][] = __('The gallery-module got deactivated.').$reload_navigation;
}

function Bilderalbum_uninstall()
{
    $GLOBALS['message'][] .= __('The gallery-module was removed from the ConPresso-system. To finally uninstall the gallery-module, please remove the module directory').' <i>'.$GLOBALS['modules']['Bilderalbum']['directory'].'</i>.';
}

function Bilderalbum_manage()
{
	global $k, $module_status;
	printIcon(
		BASE_ABS.$GLOBALS['modules']['Bilderalbum']['directory'].'/edit.php?list=options', 
		SKIN_URL.'pic_settings.gif', 
		(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE) ? __('options') : __('not available'),
		array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
	);
	printIcon(
		BASE_ABS.$GLOBALS['modules']['Bilderalbum']['directory'].'/edit.php?list=rights',
		SKIN_URL.'pic_rights.gif', 
		__('rights'),
		array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
	);
}

function Bilderalbum_navigation()
{
	global $activeModules;
	$id = $_SESSION['SID_user']['id'];
	$rights = $activeModules['Bilderalbum']['rights'][$id];
	$permission_to_see = $rights{0};
	$permission_edit = $rights{1};
	$permission_supervise = $rights{2};
	if ($permission_to_see)  {
		if ($activeModules['Bilderalbum']['menu'] == 'sub')  {
			if ($permission_edit == '1')   {
				$GLOBALS['navigation']['Modules'][] = array(
					'caption'=>'create slideshow',
					'title'=>'Creates a new slideshow',
					'url'=>BASE_URL.$activeModules['Bilderalbum']['directory'].'/edit.php?new=1'
				);
			}
			$GLOBALS['navigation']['Modules'][] = array(
				'caption'=>'work on slideshows',
				'title'=>'Manage the existing slideshows',
				'url'=>BASE_URL.$activeModules['Bilderalbum']['directory'].'/edit.php'
			);
			$GLOBALS['navigation']['Modules'][] = 'space';
		}
		if ($activeModules['Bilderalbum']['menu'] == 'main')  {
			if ($permission_edit == '1')   {
				$GLOBALS['navigation'][__('Slideshow')][] = array(
					'caption'=>'create slideshow',
					'title'=>'Creates a new slideshow',
					'url'=>BASE_URL.$activeModules['Bilderalbum']['directory'].'/edit.php?new=1'
				);
			}
			$GLOBALS['navigation'][__('Slideshow')][] = array(
				'caption'=>'work on slideshows',
				'title'=>'Manage the existing slideshows',
				'url'=>BASE_URL.$activeModules['Bilderalbum']['directory'].'/edit.php'
			);
		}
	}
}

if (!$activeModules['Bilderalbum']['installed'])  {
	$gallerydb = new DB;
	$gallerydb->query('SELECT options FROM '.CPO_OPTION.' '
			  ."WHERE type='gallery' ORDER BY id ASC LIMIT 0,1");
	while ($gallerydb->next_record()) {
		$options = $gallerydb->v('options');
		$galleryOpt = unserialize($options);
		if (!is_array($galleryOpt)) break;
		foreach ($galleryOpt as $key=>$v) {
			$activeModules['Bilderalbum'][$key] = $v;
		}
	}
}

if (	license($activeModules['Bilderalbum']['lkey'],$activeModules['Bilderalbum']['mod_id']) != 1 &&
		license($activeModules['Bilderalbum']['lkey'],$activeModules['Bilderalbum']['mod_id']) != 2 &&
		license($activeModules['Bilderalbum']['lkey'],$activeModules['Bilderalbum']['mod_id']) != 3 &&
		$activeModules['Bilderalbum']['installed']<(time()-90*24*60*60) && 
		!isset($_POST['go']) &&
		@file_exists(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/producer.inc.php')
	) 
	{
	include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/producer.inc.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	$gallerybreak = true;
} else {
	$gallerybreak = false;
    if (file_exists(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/slideshow_functions.inc.php'))  include_once(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/slideshow_functions.inc.php');
}
if (license($activeModules['Bilderalbum']['installed'],$activeModules['Bilderalbum']['mod_id']) !== false) {
    $message['license'] = '<strong>Invalid License!</strong>';
	$gallerybreak = true;
}

if ($_SESSION['SID_user']['admin']>=ROLE_EDITOR && !$gallerybreak)  $hdlr_navigation[] = 'function: Bilderalbum_navigation';
$hdlr_parser_content['slideshow']  = array('include: '.CPO_BASEDIR.$GLOBALS['modules']['Bilderalbum']['directory'].'/includes/parser_c_slideshow.inc.php');
$hdlr_parser_replacement['slideshow']  = array('include: '.CPO_BASEDIR.$GLOBALS['modules']['Bilderalbum']['directory'].'/includes/parser_r_slideshow.inc.php');

// einmal alle Bilderalben einlesen spart viele unntige Abfragen im Parser-Prozess
if (array_key_exists('Bilderalbum',$activeModules) && !isset($mod_galery_albums)) {
	$mod_galery_albums = array();
    $query = "SELECT album, beschreibung, sort, width FROM ".CPO_MOD_GALLERY." WHERE datei = '' ";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $gallerydb = new DB;
    $gallerydb->query($query);
	while($gallerydb->next_record()) {
		$mod_galery_albums[$gallerydb->v("album")]["sort"] = $gallerydb->v("sort");
		$mod_galery_albums[$gallerydb->v("album")]["beschreibung"] = $gallerydb->v("beschreibung");
		$mod_galery_albums[$gallerydb->v("album")]["width"] = $gallerydb->v("width");
	}
}

if (array_key_exists('Bilderalbum',$activeModules)) {
	// the CPO4.1 PageTemplate-Functions
	function cpoPageModGallery($_params)    { 
		global $activeModules; 
		include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/peep.inc.php'); 
		return $modGalleryPeepString; 
	}
	// the Standard-Functions for header+footer
	function ModGallery($num,$format=false,$link=false)    { 
		global $activeModules;
		$parameters = array();
		$parameters[] = 'number='.$num;
		if ($format) $parameters[] = 'format='.$format;
		if ($link) $parameters[] = 'link='.$link;
		$_params = implode(";",$parameters);
		include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/peep.inc.php'); 
		return $modGalleryPeepString; 
	}
}

