<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;

// Modulvariablen (fr weniger Schreibarbeit)
	$speed			= $activeModules['Bilderalbum']['speed'];
	$min_size		= $activeModules['Bilderalbum']['min_size'];
    $quality		= $activeModules['Bilderalbum']['quality'];
	$satzspiegel	= $activeModules['Bilderalbum']['satzspiegel'];
	$album_height	= $activeModules['Bilderalbum']['album_height'];
	$max_height		= $activeModules['Bilderalbum']['max_height'];
	$max_width		= $activeModules['Bilderalbum']['max_width'];
	$pop_up_width	= $activeModules['Bilderalbum']['pop_up_width'];
	$pop_up_height	= $activeModules['Bilderalbum']['pop_up_height'];
	$slide_frame	= $activeModules['Bilderalbum']['slide_frame'];
	$padding		= $activeModules['Bilderalbum']['padding'];
	$overview_format= $activeModules['Bilderalbum']['overview_format'];

$uploadErrors = array(
    __('File was successfully uploaded.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The file was not uploaded completely. Please try again.'),
    __('Note: No file was received. Please try again.')
);
$imageTypes = array(
    'unknown', 
    'GIF', 
    'JPG', 
    'PNG', 
    'SWF', 
    'PSD', 
    'BMP', 
    'TIFF(intel byte order)', 
    'TIFF(motorola byte order)', 
    'JPC', 
    'JP2', 
    'JPX', 
    'JB2', 
    'SWC', 
    'IFF');

$replace = array("'","\"","\\","&");

// ####################################################################################################
// Rechteeinstellungen speichern
if(isset($_GET['bilderalbum_user_id'])) {
	$bilderalbum_user_id = $_GET['bilderalbum_user_id'];
	$bilderalbum_set_rights = $_GET['set'];
	$activeModules['Bilderalbum']['rights'][$bilderalbum_user_id]=$bilderalbum_set_rights;
	save_modulesettings('cpoBilderalbumNew', 'Bilderalbum');
}

// ####################################################################################################
// Moduleinstellungen speichern
if (isset($_POST['go'])) {
	check_settings_slideshow($_POST['cpoBilderalbumNew'], $activeModules['Bilderalbum']);
	save_modulesettings('cpoBilderalbumNew', 'Bilderalbum');
}
	
// ####################################################################################################
// Bilderalbum anlegen (ohne Bilder)
if (isset($_POST['add']))  {
	$empty_value = FALSE;
	if (trim($_POST['album']) == '')	$empty_value = empty_bilderalbum_values(__('Name'));
	if ($_POST['spalten'] == '')		$_POST['spalten'] = $activeModules['Bilderalbum']['default_cols'];
	if ($_POST['spalten'] <= 1 || !is_numeric($_POST['spalten']))	  {
		$empty_value = TRUE;
		$message[] = __('The columns value must be a number greater than 1.');
	}
	if (!$empty_value)  {
		$album = $_POST['album'];
		$spalten = $_POST['spalten'];
		$titel = $_POST['titel'];
		$db = new DB;
		$query = "SELECT MAX(height) FROM ".CPO_MOD_GALLERY." WHERE datei = '' ";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db->query($query);
		$db->next_record();
		$next_height=$db->v('MAX(height)')+1;
		$query = "SELECT * FROM ".CPO_MOD_GALLERY." WHERE album='".addslashes($album)."'";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db->query($query);
		if ($db->num_rows()>0 || $album == '')  {
			$message[] = sprintf(__('The album <i>%s</i> already exists. Please choose another name.'), $album);
		}  else  {
			$query = "INSERT INTO ".CPO_MOD_GALLERY." (album, beschreibung, width, height, user) VALUES ('".addslashes($album)."', '".addslashes($titel)."', '".$spalten."', '".$next_height."', '".addslashes($_SESSION['SID_user']['name'])."')";
			DEBUG(2, $query, __FILE__, __LINE__);  
			$db->query($query);
			$message[] = sprintf(__('The album <i>%s</i> was created successfully. Now proceed to upload pictures.'), $album);
			$message[] = sprintf(__('The album was set to the state "offline" to be completed prior to publication. After completing the album <i>%s</i> you need to release it using the release button.'), $album);
		}
	}
	logaction('create slideshow', addslashes($album));
}

// ####################################################################################################
// Bilderalbum (und alle Bilder) lschen
if (isset($_GET['del']))  {
    $query = "SELECT * FROM ".CPO_MOD_GALLERY." WHERE album = '".addslashes($_GET['del'])."' AND datei <> ''";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
        while($db->next_record()):
			$PicDatei = $db->v("datei");
        
			@unlink ("bilder/".$PicDatei);
			@unlink ("bilder/".substr($PicDatei, 1));
			@unlink ("bilder/"."h".substr($PicDatei, 1));
            // x-files
            if (trim($activeModules['Bilderalbum']['x_files'])!='')  {
                $xfiles = explode("\n",trim($activeModules['Bilderalbum']['x_files']));
                foreach ($xfiles AS $xfile)  {
                    if (trim($xfile)=='') continue;
                    $xfileparms = explode(";",trim($xfile));
                    $xfilePrefix = (trim($xfileparms[0]));
                    if (empty($xfilePrefix)) continue;
                    if ($xfilePrefix=="h") continue;
                    if ($xfilePrefix=="t") continue;
                    @unlink ("bilder/".$xfilePrefix.substr($PicDatei, 1));
                }
            }

		endwhile;

    $query = "DELETE FROM ".CPO_MOD_GALLERY." WHERE album = '".addslashes($_GET['del'])."'";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    if ($db->query($query))  $message[] = sprintf(__('The album <i>%s</i> was successfully deleted.'), $_GET['del']);
	logaction('delete slideshow', addslashes($_GET['del']));
	if ($activeModules['Bilderalbum']['sorting'] == 'manual') alben_resync();
}

// ####################################################################################################
// Bildbeschreibung ndern
if (isset($_POST['changebeschreibung']))  {
    $anythingtoedit=false;
    $query = "SELECT beschreibung FROM ".CPO_MOD_GALLERY." WHERE id = ".(int)$_POST['id'];
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
    $db->next_record();
    if ($_POST['beschreibung'] != $db->v('beschreibung'))	{
        $query = "UPDATE ".CPO_MOD_GALLERY." SET beschreibung = '".addslashes($_POST['beschreibung'])."' WHERE id = ".(int)$_POST['id'];
        DEBUG(2, $query, __FILE__, __LINE__);  
        $db = new DB;
        $db->query($query);
        $message[] = sprintf(__('The description was successfully changed to <i>%s</i>.'), $_POST['beschreibung']);
        $anythingtoedit=true;
        logaction('edit slideshow image description', addslashes($_POST['id']));
    }
    if ($_POST['album'] != $_POST['edit'])	{
        $query = "SELECT max(sort) AS letztes FROM ".CPO_MOD_GALLERY." WHERE album = '".addslashes($_POST['album'])."' ";
        DEBUG(2, $query, __FILE__, __LINE__);  
        $db = new DB;
        $db->query($query);
        $db->next_record();
        $newSort = $db->v("letztes")+1;
        $query = "UPDATE ".CPO_MOD_GALLERY." SET album = '".addslashes($_POST['album'])."', sort = ".$newSort." WHERE id = ".(int)$_POST['id'];
        DEBUG(2, $query, __FILE__, __LINE__);  
        $db = new DB;
        $db->query($query);
       $message[] = sprintf(__('The picture was moved to the end of album <i>%s</i>.'), $_POST['album']);
        bilderalbum_resync($_POST['album']);
        bilderalbum_resync($_POST['edit']);
        $message[] = sprintf( __('The sorting of <i>%s</i> and <i>%s</i> was redone!'), htmlspecialchars($_POST['album'], ENT_COMPAT, 'ISO-8859-15'), htmlspecialchars($_POST['edit'], ENT_COMPAT, 'ISO-8859-15') );
        logaction('moved slideshow image', addslashes($_POST['id']));
        $anythingtoedit=true;
    }
    if (!$anythingtoedit) $message[] = __('No changes!');
}

// ####################################################################################################
// Einzelbilder lschen
if (isset($_GET['delpic']))  {
	$deletepic = $_GET['delpic'];
		@unlink ("bilder/".$deletepic);
		@unlink ("bilder/t".$deletepic);
		@unlink ("bilder/h".$deletepic);
        // x-files
        if (trim($activeModules['Bilderalbum']['x_files'])!='')  {
            $xfiles = explode("\n",trim($activeModules['Bilderalbum']['x_files']));
            foreach ($xfiles AS $xfile)  {
                if (trim($xfile)=='') continue;
                $xfileparms = explode(";",trim($xfile));
                $xfilePrefix = (trim($xfileparms[0]));
                if (empty($xfilePrefix)) continue;
                @unlink ("bilder/".$xfilePrefix.$deletepic);
            }
        }
    $query = "DELETE FROM ".CPO_MOD_GALLERY." WHERE datei = 't".addslashes($deletepic)."'";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
	// Positionen neu durchnummerieren!
	$sort = $_GET['sort'];
	$q = "UPDATE ".CPO_MOD_GALLERY." "
		."SET sort=sort-1 "
		."WHERE album='".addslashes($_GET['edit'])."' "
		."AND sort>'".$sort."'";
	DEBUG(1, $q, __FILE__, __LINE__);
	$db->query($q);
	logaction('delete slideshow image', $deletepic);
}

// ####################################################################################################
// Reihenfolge korrigieren (resync)
if (isset($_GET['resync']))  {
    bilderalbum_resync($_GET['resync']);
    $message[] = sprintf( __('The sorting of the album <i>%s</i> was redone!'), htmlspecialchars($_GET['resync'], ENT_COMPAT, 'ISO-8859-15') );
	logaction('resync slideshow', addslashes($resync));
}


// ####################################################################################################
// Albumname ndern
if (isset($_POST['newlayout']) AND htmlspecialchars($_POST['newname'], ENT_COMPAT, 'ISO-8859-15') != htmlspecialchars($_POST['album'], ENT_COMPAT, 'ISO-8859-15'))  {
	$query = "SELECT * FROM ".CPO_MOD_GALLERY." WHERE album='".addslashes($_POST['newname'])."'";
	DEBUG(2, $query, __FILE__, __LINE__);  
	$db = new DB;
	$db->query($query);
	if ($db->num_rows()>0)  {
		$message[] = sprintf(__('The album <i>%s</i> already exists. Please choose another name.'), $_POST['newname']);
		$empty_value = TRUE;
	}  elseif (trim($_POST['newname']) == '')	{
		$empty_value = empty_bilderalbum_values(__('Name'));
	}
	if (!$empty_value)  {
		$query = "UPDATE ".CPO_MOD_GALLERY." SET album = '".addslashes($_POST['newname'])."' WHERE album = '".addslashes($_POST['album'])."'";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db = new DB;
		$db->query($query);
		$message[] = sprintf(__('The album <i>%s</i> was successfully renamed to <i>%s</i>.'), htmlspecialchars($_POST['album'], ENT_COMPAT, 'ISO-8859-15'), htmlspecialchars($_POST['newname'], ENT_COMPAT, 'ISO-8859-15'));
		$_POST['album'] = $_POST['newname'];
	}
}

// ####################################################################################################
// Albumbeschreibung ndern
if (isset($_POST['newlayout']) AND htmlspecialchars($_POST['beschreibung'], ENT_COMPAT, 'ISO-8859-15') != htmlspecialchars($_POST['oldbeschreibung'], ENT_COMPAT, 'ISO-8859-15'))  {
    $query = "UPDATE ".CPO_MOD_GALLERY." SET beschreibung = '".addslashes($_POST['beschreibung'])."' WHERE album = '".addslashes($_POST['album'])."' AND datei = ''";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
    $message[] = sprintf(__('The description of the album <i>%s</i> was changed to <i>%s</i>.'), htmlspecialchars($_POST['album'], ENT_COMPAT, 'ISO-8859-15'), htmlspecialchars($_POST['beschreibung'], ENT_COMPAT, 'ISO-8859-15'));
}

// ####################################################################################################
// Album freischalten
if (isset($_GET['release']))  {
    $query = "UPDATE ".CPO_MOD_GALLERY." SET sort = -1 WHERE album = '".addslashes($_GET['release'])."' AND datei = ''";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
    $message[] = sprintf(__('The album <i>%s</i> was released.'), htmlspecialchars($_GET['release'], ENT_COMPAT, 'ISO-8859-15'));
	logaction('release slideshow', addslashes($_GET['release']));
}
// Album blocken
if (isset($_GET['block']))  {
    $query = "UPDATE ".CPO_MOD_GALLERY." SET sort = NULL WHERE album = '".addslashes($_GET['block'])."' AND datei = ''";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
    $message[] = sprintf(__('The album <i>%s</i> was blocked.'), htmlspecialchars($_GET['block'], ENT_COMPAT, 'ISO-8859-15'));
	logaction('block slideshow', addslashes($_GET['block']));
}

// ####################################################################################################
// Thumbs umrechnen wegen neuer Spaltenzahl
if (isset($_POST['newlayout']) AND $_POST['spalten'] != $_POST['oldcols'])  {
	if ($_POST['spalten'] <= 1 || !is_numeric($_POST['spalten']))	  {
		$empty_value = TRUE;
		$message[] = __('The columns value must be a number greater than 1.');
	}
	if (!$empty_value)  {
		$album = $_POST['album'];
		$spalten = $_POST['spalten'];
		$beschreibung = $_POST['beschreibung'];
		$path = CPO_BASEDIR.$activeModules['Bilderalbum']['directory']."/bilder/";

	// Bestimmung der Diagre
		if ($overview_format == 'table')
		{
			$dia_size = floor (($satzspiegel - (($spalten - 1) * $padding)) / $spalten);
			$thumbsize = floor ($dia_size - (2 * $slide_frame));
		}
		if ($overview_format == 'pics')
		{
			$thumbsize = $activeModules['Bilderalbum']['image_size'];
		}
		
		$query = "SELECT * FROM ".CPO_MOD_GALLERY." WHERE album = '".addslashes($album)."' AND datei <> ''";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db = new DB;
		$db->query($query);
		$total = $db->num_rows();
		while($db->next_record()):

		// Bilder laden
			$filename = substr($db->v("datei"),1);
			$imagefile = ImageCreateFromJPEG("bilder/".$filename);
			$breite = imagesx($imagefile);
			$hoehe = imagesy($imagefile);

			// Thumnails erstellen
			slideshow_thumbnail($path.$filename, $thumbsize, "bilder/t".$filename, $quality);

		endwhile;

		$query = "UPDATE ".CPO_MOD_GALLERY." SET width = '".$spalten."', beschreibung = '".addslashes($beschreibung)."' WHERE album = '".addslashes($album)."' AND datei = ''";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db = new DB;
		$db->query($query);
		$message[] = sprintf(__('The number of colums was changed to %s and %s thumbnails were resampled to %s pixels.'), $spalten, $total, $thumbsize);
	}
}

// ####################################################################################################
// Bildreihenfolge ndern
$actionArray = array('up','top','ff','rew','bottom','down'); // erlaubte Bildaktionen
$typeArray   = array('pic','album'); // erlaubte Typen
if ( in_array($_REQUEST['action'], $actionArray ) && in_array($_REQUEST['type'], $typeArray ) ) {

	switch ($_REQUEST['type'])  {
	case 'pic': // start pic sort
		$editalbum = addslashes($_GET['edit']);
		$picID = addslashes($_GET['id']);

		// schnell mal die Eckwerte ermitteln
		$query = "SELECT * FROM ".CPO_MOD_GALLERY." WHERE album = '".$editalbum."' AND datei <> '' ORDER BY sort";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db = new DB;
		$db->query($query);
		$total = $db->num_rows();
		if ($db->num_rows()>0)  {
			while($db->next_record()):
				// sort-Position des gewhlten Bildes ermitteln
				if ( $db->v("id") == $picID )  {
					$sort = $db->v("sort");
				}
			endwhile;
		}
		$query2 = "SELECT datei, width, beschreibung FROM ".CPO_MOD_GALLERY." WHERE album='".$editalbum."'";
		DEBUG(2, $query2, __FILE__, __LINE__);  
		$db2 = new DB;
		$db2->query($query2);
		$bilderzahl = $db2->num_rows()-1;
			while($db2->next_record()):
				if ($db2->v("datei") == '')  {
					$spalten = $db2->v("width");
					$beschreibung = $db2->v("beschreibung");
				}
			endwhile;
		$zeilen = (integer)  (($bilderzahl/$spalten)+0.99);
		$offset = $spalten; // bedeutet soviel wie eine Zeile nach oben
		
		$dbq = new DB;
		switch ($_REQUEST['action']) {
			case 'up':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort+1 "
					."WHERE album='".$editalbum."' "
					."AND sort='".($sort-1)."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort-1 "
					."WHERE id='".$picID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'top':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort+1 "
					."WHERE album='".$editalbum."' "
					."AND sort>0 "
					."AND sort<'".$sort."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=1 "
					."WHERE id='".$picID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'ff':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort-1 "
					."WHERE album='".$editalbum."' "
					."AND sort>".$sort." "
					."AND sort<=".$sort."+".$offset;
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=LEAST(".($sort+$offset).",".$total.") "
					."WHERE id='".$picID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'rew':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort+1 "
					."WHERE album='".$editalbum."' "
					."AND sort<".$sort." "
					."AND sort>=".($sort-$offset);
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=GREATEST(".($sort-$offset).",1) "
					."WHERE id='".$picID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'bottom':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort-1 "
					."WHERE album='".$editalbum."' "
					."AND sort>'".$sort."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=".$total." "
					."WHERE id='".$picID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$_GET['pholder']=$count_placeholders;
				break;

			case 'down':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort-1 "
					."WHERE album='".$editalbum."' "
					."AND sort='".($sort+1)."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET sort=sort+1 "
					."WHERE id='".$picID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;
		}
	break; // end pic sort

	case 'album':  // start album sort
		$editalbum = addslashes($_GET['edit']);
		$albumID = addslashes($_GET['id']);

		// schnell mal die Eckwerte ermitteln
		$query = "SELECT * FROM ".CPO_MOD_GALLERY." ORDER BY height";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db = new DB;
		$db->query($query);
		$total = $db->num_rows(); // Anzah der Alben
		$count=1;
		while($db->next_record()):
			$albums[$count] = array(
				'nr'=>$count,
				'spalten'=>$db->v("width"),
				'beschreibung'=>$db->v("beschreibung"),
				'height'=>$db->v("height")
			);
		endwhile;

		$query2 = "SELECT datei, width, height, beschreibung FROM ".CPO_MOD_GALLERY." WHERE id='".$albumID."'";
		DEBUG(2, $query2, __FILE__, __LINE__);  
		$db2 = new DB;
		$db2->query($query2);
		$bilderzahl = $db2->num_rows()-1;
		while($db2->next_record()):
			$spalten = $db2->v("width");
			$beschreibung = $db2->v("beschreibung");
			$height = $db2->v("height");
		endwhile;
		$offset = min($total-1,4);

		$dbq = new DB;
		switch ($_REQUEST['action']) {
			case 'up':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height+1 "
					."WHERE height='".($height-1)."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height-1 "
					."WHERE id='".$albumID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'top':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height+1 "
					."WHERE height>0 "
					."AND height<'".$height."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=1 "
					."WHERE id='".$albumID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'ff':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height-1 "
					."WHERE height>".$height." "
					."AND height<=".$height."+".$offset;
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=LEAST(".($height+$offset).",".$total.") "
					."WHERE id='".$albumID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'rew':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height+1 "
					."WHERE height<".$height." "
					."AND height>=".($height-$offset);
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=GREATEST(".($height-$offset).",1) "
					."WHERE id='".$albumID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;

			case 'bottom':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height-1 "
					."WHERE height>'".$height."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=".$total." "
					."WHERE id='".$albumID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$_GET['pholder']=$count_placeholders;
				break;

			case 'down':
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height-1 "
					."WHERE height='".($height+1)."'";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				$q = "UPDATE ".CPO_MOD_GALLERY." "
					."SET height=height+1 "
					."WHERE id='".$albumID."' ";
				DEBUG(1, $q, __FILE__, __LINE__);
				$dbq->query($q);
				break;
		}
		break;
	}
	alben_resync();
}

// ####################################################################################################

// Files wurden hochgeladen durch Formular
if (isset($_POST['files']))  {  
	// some values
	$counter = 1;
	$path = CPO_BASEDIR.$activeModules['Bilderalbum']['directory']."/bilder/";
	$cols = $_POST['cols'];
	if ($overview_format == 'table')
	{
		$dia_size = floor (($satzspiegel - (($cols - 1) * $padding)) / $cols);
		$thumbsize = floor ($dia_size - (2 * $slide_frame));
	}
	if ($overview_format == 'pics')
	{
		$thumbsize = $activeModules['Bilderalbum']['image_size'];
	}
	$t_datum = date ("YmdHmi" ,time());
	$autor = $_SESSION['SID_user']['name'];

	for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {
		if ($_FILES['uppedFiles']['name'][$i]=='') continue;
		$upped = true;
		break;
	}
	if (!$upped) {
		$message[] = __('No file was uploaded.');
		include(CPO_BASEDIR.'_include/message.php');
		return;
	}

	echo '<table class="colored" style="width: 100%;">';
	echo '<thead><tr>';
	echo '<th colspan="2"><span>' . __('Uploaded files') . '</span></th>';
	echo '</tr>';
	echo '</thead><tbody>';

	for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {  // do the loop ******************
		if ($_FILES['uppedFiles']['name'][$i]=='') {
			continue;
		}
		echo '<tr>';
		echo '<td class="leftrow">' . sprintf('<b>%d) %s</b>', $counter++, htmlspecialchars($_FILES['uppedFiles']['name'][$i], ENT_COMPAT, 'ISO-8859-15')) . '</td>';
		echo '<td class="rightrow"> ';
	// check for errors
		if (!$_FILES['uppedFiles']['size'][$i]) {
			if (isset($_FILES['uppedFiles']['error'][$i])) // this exists since PHP 4.2
				 $error = $uploadErrors[$_FILES['uppedFiles']['error'][$i]];
			// else guess the error...
			else $error = __('Unknown ERROR: Please check if the size of the file exceeds the maximum uploadable file size.');
			printf(htmlspecialchars(__('ERROR: There was an error: %s'), ENT_COMPAT, 'ISO-8859-15').'<br />', htmlspecialchars($error, ENT_COMPAT, 'ISO-8859-15')
			);
			echo '</td></tr>';
			continue;
		}

		// modify filename to exclude characters that are not a-z A-Z 0-9 _ or .
		$filename = $_FILES['uppedFiles']['name'][$i];
		$filename = preg_replace('/[^a-z0-9_\.-]/i', '_', $filename);

        // add a prefix if file exists
        $prefix = ''; 
        $prefixNo = 0;
        while (file_exists($path.$prefix.$filename)) {
            $prefixNo++;
            $prefix = $prefixNo.'-';
        }
        $new_filename = $path.$prefix.$filename;

		if (file_exists($path.$filename)) printf('<img src="'.SKIN_URL.'sym_note.gif"> '.__('This file did already exist.<br />To avoid overwriting the old file, a prefix got added: <em>%s</em>.').'<br />',	$prefix);

		// move the uploaded file to the new place
		if (!@move_uploaded_file($_FILES['uppedFiles']['tmp_name'][$i], $new_filename)) {
			echo '<img src="'.SKIN_URL.'sym_info.gif"> ';
			printf(__('Unable to move the file <em>%s</em>! Make sure the webserver has write-access to the directory <em>%s</em>').'<br />', htmlspecialchars($new_filename, ENT_COMPAT, 'ISO-8859-15'), htmlspecialchars(dirname($new_filename), ENT_COMPAT, 'ISO-8859-15'));
			continue;
			echo '</td></tr>';
		}
		// check for 4C-Jpeg
		if (($_FILES['uppedFiles']['type'][$i] == 'image/pjpeg' OR $_FILES['uppedFiles']['type'][$i] == 'image/jpeg') AND !@ImageCreateFromJPEG($new_filename))  {
			@unlink($new_filename);
			echo '<img src="'.SKIN_URL.'sym_info.gif"> ';
			print(__('This might be a 4C-Jpeg that can not be processed!'));
			echo '</td></tr>';
			continue;
		}
		// check for others than jpeg
		if ($_FILES['uppedFiles']['type'][$i] != 'image/pjpeg' AND $_FILES['uppedFiles']['type'][$i] != 'image/jpeg')  {
			@unlink($new_filename);
			echo '<img src="'.SKIN_URL.'sym_info.gif"> ';
			print(__('This is not a JPEG!'));
			echo '</td></tr>';
			continue;
		}
		@chmod($new_filename, 0666);

        // Check if it is an image suitable for album (only JPG)
        $checkImage = @getimagesize($new_filename);
        if ($checkImage && $imageTypes[$checkImage[2]]=='JPG') {

        // if the image-file is too big, delete it and continue
        if ($_FILES['uppedFiles']['size'][$i] > $cpoSystem['max_image']) {
            @unlink($new_filename);
            printf('<img src="'.SKIN_URL.'sym_warning.gif"> '.htmlspecialchars(__('The file was %s bigger than the allowed maximum size of %s for images. Because of that the file was deleted. Please contact your administrator if you think this is an error.'), ENT_COMPAT, 'ISO-8859-15'),
                '<em>'.printHumanReadable($cpoSystem['max_image']-$_FILES['uppedFiles']['size'][$i]).'</em>',
                '<em>'.printHumanReadable($cpoSystem['max_image']).'</em>'
            );
            print('<br />');
            continue;
        }
        printf(__('The file is an image of type <em>%s</em> and is suitable for webpages.').'<br />',
            $imageTypes[$checkImage[2]]);

			// Zu kleine Bilder werden abgelent
            if ($checkImage[0] < $min_size AND $checkImage[1] < $min_size) {
            @unlink($new_filename);
			print('<img src="'.SKIN_URL.'sym_info.gif"> ');
            printf(__('<b>Your image is too small to be used in the slideshow!</b> The image dimension (%s x %s) is smaller than the required slideshow minimum of %s pixels.').'<br />',
                '<em>'.$checkImage[0].'</em>',
                '<em>'.$checkImage[1].'</em>',
                '<em>'.$activeModules['Bilderalbum']['min_size'].'</em>'
            );
            continue;
            }

			// finding last position
			$query = "SELECT max(sort) AS last FROM ".CPO_MOD_GALLERY." WHERE album='".addslashes($_POST['album'])."'";
			DEBUG(1, $query, __FILE__, __LINE__);   
			$db = new DB;
			$db->query($query);
			$db->next_record();
			$last = max(0,$db->v('last'));

            $query = "INSERT INTO ".CPO_MOD_GALLERY." (id, beschreibung, datei, size, width, height, user, album, timestamp, sort) values('', '".addslashes($_POST['beschreibung'][$i])."', 't".$prefix.$filename."', '".$_FILES['uppedFiles']['size'][$i]."', '".$checkImage[0]."', '".$checkImage[1]."', '".$autor."', '".addslashes($_POST['album'])."', '".$t_datum."', ".($last+1).")";

			if ($_FILES['uppedFiles']['type'][$i] == 'image/pjpeg' OR $_FILES['uppedFiles']['type'][$i] == 'image/jpeg')  {

				// Thumnails erstellen
				slideshow_thumbnail($new_filename, $thumbsize, $path."t".$prefix.$filename, $quality);

				// Bilder skalieren auf Standard
				slideshow_picture($new_filename, $max_width, $max_height, $path."h".$prefix.$filename, $quality);

				// x-files
                if (trim($activeModules['Bilderalbum']['x_files'])!='')  {
                    $xfiles = explode("\n",trim($activeModules['Bilderalbum']['x_files']));
                    foreach ($xfiles AS $xfile)  {
                        if (trim($xfile)=='') continue;
                        $xfileparms = explode(";",trim($xfile));
                        $xfilePrefix = (trim($xfileparms[0]));
                        $xfileWidth = (trim($xfileparms[1]));
                        $xfileHeight = (trim($xfileparms[2]));
                        if (empty($xfilePrefix)) continue;
                        if (empty($xfileWidth)) continue;
                        if (empty($xfileHeight)) continue;
                        if ($xfilePrefix=="h") continue;
                        if ($xfilePrefix=="t") continue;

                        slideshow_picture($new_filename, $xfileWidth, $xfileHeight, $path.$xfilePrefix.$prefix.$filename, $quality);
                        printf('<img src="'.SKIN_URL.'sym_note.gif"> '.__('An additional file was created and saved as <em>%s</em>.').'<br />',
                            htmlspecialchars($xfilePrefix.$prefix.$filename, ENT_COMPAT, 'ISO-8859-15')
                            );
                    }
                }
			}

        } else {
            // no image 

			@unlink($new_filename);
            // if the file is too big, delete it and continue
				printf('<img src="'.SKIN_URL.'sym_warning.gif"> '.__('The file %s is no image an has been deleted!.'),
					'<em>'.$new_filename.'</em>'
				);
				echo '<br />';
			continue;
        }

        // print infos
		printf(__('File was uploaded and saved as <em>%s</em>.').'<br />'.
			   __('The file has a size of <em>%s</em>.').'<br />',
			htmlspecialchars($prefix.$filename, ENT_COMPAT, 'ISO-8859-15'),
			printHumanReadable(filesize($new_filename))
			);
		print('</td></tr>');
		logaction('upload slideshow image', $prefix.$filename);

        // store in database
        DEBUG(1, $query, __FILE__, __LINE__);   
        $db = new DB;
        $db->query($query);
    }
echo '</tbody></table>';
}

?>