<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;

if (is_dir(substr(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/skin/'.$CPO['skin'],0,-1))) define('GAL_SKIN_URL', BASE_REL.$activeModules['Bilderalbum']['directory'].'/skin/'.$CPO['skin']);
else define('GAL_SKIN_URL', BASE_REL.$activeModules['Bilderalbum']['directory'].'/skin/conpresso/'); // Fallback to conpresso

// Bilderalbum-Rechte
$id = $_SESSION['SID_user']['id'];
$rights = $activeModules['Bilderalbum']['rights'][$id];
$permission_to_see = $rights{0};
$permission_edit = $rights{1};
$permission_supervise = $rights{2};

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

printPageHeader(
    __('Slideshow'),
    __('In this view you can work on the existing slideshows.'),
    modHelp('application','gallery'),
    true,
    'modules'
);
	

require(CPO_BASEDIR."_include/message.php");
if (!$gallerybreak) {

	include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/actions.inc.php');


    switch ($_REQUEST['action']) {
    case 'togglefilter':
        $_SESSION['filter_albums']['enabled'] = !$_SESSION['filter_albums']['enabled'];

        if ($_SESSION['filter_albums']['enabled']) break;
        $_SESSION['filter_albums']['phrase'] = '';
        break;
    case 'setfilter':
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('album set filter', 'CSRF check failed.');
            break;
        }
        $_SESSION['SID_pagers'][$pager] = 0;
        $_SESSION['filter_albums']['phrase'] = $_POST['phrase'];
        break;
    }

	if (!isset($_SESSION['filter_albums'])) {
		$_SESSION['filter_albums'] = array(
			'enabled' => false,
			'phrase' => '',
		);
	}

	if (!$_SESSION['filter_albums']['enabled']) {
		echo '<table style="width: 100%;" class="colored filter"><thead>';
		echo '<tr>';
		printf('<th><span><a href="%1$s">'
			. '<img src="' . SKIN_URL . 'sym_filteron.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
			. '&nbsp;<a href="%1$s">%2$s</a>' .help('') . '</span></th>',
			$_SERVER['PHP_SELF'] . '?action=togglefilter',
			___('Enable filter')
		);
		echo '</tr></table>';
	} else {
		echo '<table style="width: 100%;" class="colored"><thead>';
		echo '<tr>';
		printf('<th colspan="3"><span><a href="%1$s">'
			. '<img src="' . SKIN_URL . 'sym_filteroff.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
			. '&nbsp;<a href="%1$s">%2$s</a>' . help('') . '</span></th>',
			$_SERVER['PHP_SELF'] . '?action=togglefilter',
			___('Disable filter')
		);
		echo '</tr></thead><tbody><tr>';

		echo '<form method="post" action="' . $_SERVER["PHP_SELF"] . ' " name="newsentry">';
		$antiCSRF->printInput('setfilter');
		echo '<td class="leftrow">';
		echo ___('Filter by phrase:').'</td><td>';
		printf('<input type="text" name="%s" value="%s" class="inputwidth">' . help(''),
			'phrase',
			htmlspecialchars($_SESSION['filter_albums']['phrase'], ENT_COMPAT, 'ISO-8859-15')
		);
		echo '</td></tr><td>&nbsp;</td><td>';
		echo '<input type="submit" class="button" value="' . ___('Set filter parameters') . '">';
		echo '</td>';
		echo '</form>';
		echo '</tr></tbody></table>';
	}

    if (!empty($_SESSION['filter_albums']['phrase'])) {
		$q_phrase .=
			 "AND ( album LIKE '%" . addslashes($_SESSION['filter_albums']['phrase'])."%' "
			 ."OR beschreibung LIKE '%" . addslashes($_SESSION['filter_albums']['phrase'])."%') ";
	}
	$sorting = ($activeModules['Bilderalbum']['sorting'] == 'manual') ? 'height' : 'album';
	$query = "SELECT album, height, user, sort FROM ".CPO_MOD_GALLERY." WHERE datei = '' ".$q_phrase." ORDER BY ".$sorting." ";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
    if ($db->num_rows()<1)  {
			$rights = $activeModules['Bilderalbum']['rights'][$id];
			$permission_to_see = $rights{0};
			$permission_edit = $rights{1};
			$permission_supervise = $rights{2};
			if ($permission_edit == '1')   {
				$message[] = __('No albums founds!').' '
				.sprintf(___('You can %screate a new album%s.'),
					'<a href="'.BASE_REL.'mod_gallery/edit.php?new=1">',
					'</a>');
			} else {
				$message[] = __('No albums founds!');
			}
	}
	require(CPO_BASEDIR."_include/message.php");

	//Album Liste
	$total = $db->num_rows();
	$offset = min($total-1,4);
    if ($db->num_rows()>0){
		// table header {{{
        echo '<table class="ruler" style="width: 100%;">';
        echo '<thead><tr>';
        if ($activeModules['Bilderalbum']['sorting'] == 'manual' && $_SESSION['filter_albums']['phrase'] == '') echo '<th style="width: 1%;"></th>';
        echo '<th style="width: 50%;"><span>'.__('Name').'</span></th>';
		if ($permission_edit == '1')   {
			if ($overview_format == 'table')  echo '<th style="width: 20%;"><span>' . __('Format') . '</span></th>';
			echo '<th style="width: 20%;"><span>'.__('Pictures').'</span></th>';
			echo '<th style="width: 10%;"><span>'.__('Action').'</span></th>';
		}
		echo '</tr></thead><tbody>';

        while($db->next_record()):
			$album = $db->v("album");
			$user = $db->v("user");
			$online = $db->v("sort");
			$sort_id = $db->v("height");
			$id = $db->v("id");
			$not_available = sprintf(__('this slideshow is owned by the user %s, so you&#39;re nor allowed to work on it'), htmlspecialchars($user, ENT_COMPAT, 'ISO-8859-15'));
		    $query_volume = "SELECT sum(size) AS volumen FROM ".CPO_MOD_GALLERY." WHERE album='".addslashes($album)."'";
		    DEBUG(2, $query_volume, __FILE__, __LINE__);  
			$db_volume = new DB;
		    $db_volume->query($query_volume);
			$db_volume->next_record();
			$volumen = $db_volume->v("volumen");
		    $query2 = "SELECT id, datei, width, height, beschreibung FROM ".CPO_MOD_GALLERY." WHERE album='".addslashes($album)."'";
		    DEBUG(2, $query2, __FILE__, __LINE__);  
			$db2 = new DB;
		    $db2->query($query2);
			$bilderzahl = $db2->num_rows()-1;
				while($db2->next_record()):
					if ($db2->v("datei") == '')  {
						$id = $db2->v("id");
						$spalten = $db2->v("width");
						$beschreibung = $db2->v("beschreibung");
						$height = $db2->v("height");
					}
				endwhile;
			$zeilen = (integer)  (($bilderzahl/$spalten)+0.99);
			echo "<tr>";
			if ($activeModules['Bilderalbum']['sorting'] == 'manual' && $_SESSION['filter_albums']['phrase'] == '') {
				echo '<a name="id'.$id.'"></a>';
				echo '<td style="text-align: center; white-space:nowrap;">';
				bilderalbum_sort($id, $height, 'album');
				echo "</td>";
			}
			echo "<td>";
			echo ($online) ? '<img src="'.SKIN_URL.'sym_published.gif" alt="online"> ' : '<img src="'.SKIN_URL.'sym_not-published.gif" alt="offline"> ';
			if (substr(addslashes($album),strlen($activeModules['Bilderalbum']['member_suffix'])*-1)==$activeModules['Bilderalbum']['member_suffix']) echo ' <img src="'.SKIN_URL.'lock1.gif" alt="'.sprintf(__('This album will be show to logged in users only because of the trailing suffix \'%s\''),$activeModules['Bilderalbum']['member_suffix']).'"> ';
			echo "<a href=\"preview.php?show=".urlencode($album)."\" target=\"_blank\">";
			echo htmlspecialchars($album, ENT_COMPAT, 'ISO-8859-15')."</a>";
			if (trim($beschreibung)!='') echo "<br />(".htmlspecialchars($beschreibung, ENT_COMPAT, 'ISO-8859-15').")";
			echo "</td>";
		if ($permission_edit == '1')   {
			if ($overview_format == 'table')  {	
				echo "<td>";
				echo $spalten."&nbsp;".__('columns')."&nbsp;x<br />".$zeilen."&nbsp;".__('rows');
				echo "</td>";
			}
			echo "<td>";
				if ($user == $_SESSION['SID_user']['name'] || $permission_supervise) {
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php?edit='.urlencode($album).'&cols='.$spalten,
                        SKIN_URL.'pic_edit.gif',
                        ___('organize'),
                        true
                    );
				} else {
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php?edit='.urlencode($album).'&cols='.$spalten,
                        SKIN_URL.'pic_edit.gif',
                        $not_available,
                        false
                    );
				}
			echo $bilderzahl." ".__('Pictures')."<br />(".printhumanreadable($volumen).")";
			echo "</td>";
			echo '<td nowrap="nowrap">';
				if ($user == $_SESSION['SID_user']['name'] || $permission_supervise) {
					// release/block
					if ($online) {
                        printIcon(
                            BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php?release='.urlencode($album),
                            SKIN_URL.'pic_free.gif',
                            ___('This album is already released'),
                            false
                        );
                        printIcon(
                            BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php?block='.urlencode($album),
                            SKIN_URL.'pic_block.gif',
                            ___('block'),
                            true
                        );
					} else {
                        printIcon(
                            BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php?release='.urlencode($album),
                            SKIN_URL.'pic_free.gif',
                            ___('release'),
                            true
                        );
                        printIcon(
                            BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php?block='.urlencode($album),
                            SKIN_URL.'pic_block.gif',
                            ___('This album is already blocked'),
                            false
                        );
					}
					// edit
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'] . '/edit.php?layout=' . urlencode($album),
                        SKIN_URL.'pic_settings.gif',
                        ___('edit'),
                        true
                    );
					// delete
					echo '<a href="'.BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php?del='.urlencode($album).'" onClick="return confirm(\''.__('Do you really want to delete this slideshow and all the pictures?').'\')">';
					echo '<img src="'.SKIN_URL.'pic_del.gif" alt="'.__('delete').'" title="'.__('delete').'" />'; 
					echo '</a>';
					// resync
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'] . '/edit.php?resync=' . urlencode($album),
                        GAL_SKIN_URL.'pic_resync.gif',
                        ___('resync'),
                        true
                    );
				} else {
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php',
                        SKIN_URL.'pic_free.gif',
                        $not_available,
                        false
                    );
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php',
                        SKIN_URL.'pic_block.gif',
                        $not_available,
                        false
                    );
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php',
                        SKIN_URL.'pic_settings.gif',
                        $not_available,
                        false
                    );
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php',
                        SKIN_URL.'pic_del.gif',
                        $not_available,
                        false
                    );
                    printIcon(
                        BASE_REL.$activeModules['Bilderalbum']['directory'].'/edit.php',
                        GAL_SKIN_URL.'pic_resync.gif',
                        $not_available,
                        false
                    );
				}
			echo "</td>";
		}
		echo "</tr>";
        endwhile;

		echo '</tbody></table>';
    }

    // ein paar Warnmeldungen
    if ($activeModules['Bilderalbum']['usage_message'] == 'yes')  {
        $message[] = __('NOTICE: The galleries can\'t be shown by using a URL! Just put a SLIDESHOW placeholder in your article template and the gallery matching the article title will be shown.');
    }
    require(CPO_BASEDIR."_include/message.php");



}
?>