<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;

$cols = $mod_galery_albums[$_GET['layout']]["width"];
$beschreibung = $mod_galery_albums[$_GET['layout']]["beschreibung"];

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

printPageHeader(
	__('Change slideshow layout'),
	sprintf(__('In this view you can change the main values of the slideshow <i>%s</i>.'), htmlspecialchars($_GET['layout'], ENT_COMPAT, 'ISO-8859-15')),
    modHelp('application','gallery'),
    true,
    'modules'
);

include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/actions.inc.php');
?>
<FORM METHOD=POST ACTION="edit.php">
<input type="hidden" name="newlayout" value="1">
<input type="hidden" name="album" value="<?php echo htmlspecialchars($_GET['layout'], ENT_COMPAT, 'ISO-8859-15'); ?>">
<input type="hidden" name="oldcols" value="<?php echo $cols; ?>">
<?php if ($overview_format == 'pics') { ?>
<input type="hidden" name="spalten" value="<?php echo $cols; ?>">
<?php } ?>
<input type="hidden" name="oldbeschreibung" value="<?php echo htmlspecialchars($beschreibung, ENT_COMPAT, 'ISO-8859-15'); ?>">
<table class="colored" style="width: 100%;">
	<thead>
		<tr>
			<th colspan="2"><span><?php echo __('Change slideshow main values'); ?></span></th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td class="leftrow"><?php echo __('Name'); ?>:</td>
			<td class="rightrow"><INPUT class="text inputwidth" TYPE="text" NAME="newname" value="<?php echo htmlspecialchars($_GET['layout'], ENT_COMPAT, 'ISO-8859-15'); ?>"  size="20" maxlength="255"></td>
		</tr>
		<tr>
			<td class="leftrow"><?php echo __('Description'); ?>:</td>
			<td class="rightrow"><INPUT TYPE="text" class="text inputwidth" NAME="beschreibung" value="<?php echo htmlspecialchars($beschreibung, ENT_COMPAT, 'ISO-8859-15'); ?>" size="20" maxlength="255"></td>
		</tr>
		<?php if ($overview_format == 'table') { ?>
		<tr>
			<td><?php echo __('Columns'); ?>:</td>
			<td><INPUT TYPE="text" class="text" NAME="spalten" value="<?php echo $cols; ?>" size="1"></td>
		</tr>
		<?php } ?>
		<tr>
			<td>&nbsp;</td>
			<td><INPUT TYPE="submit" name="send" value="<?php echo __('change'); ?>"></td>
		</tr>
		<?php if ($overview_format == 'table') { ?>
		<tr>
			<td>&nbsp;</td>
			<td><?php echo __('Please be patient after pressing the change button if you have changed the number of columns, because all thumbnails have to be resampled to the new size.'); ?></td>
		</tr>
		<?php } ?>
	</tbody>
</table>
</FORM>
