<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

printPageHeader(
    __('Edit slideshow rights'),
    __('This view allows you to change the rights of the users for the slideshow-module.'), 
    modHelp('rights','gallery'),
    true,
    'modules'
);

require(CPO_BASEDIR."_include/message.php");

if (!$gallerybreak) {
    include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/actions.inc.php');

    $right_on  = '<img src="'.SKIN_URL.'pic_rights_off.gif" alt="'.__('switch rights off').'" title="'.__('switch rights off').'">';
    $right_off = '<img src="'.SKIN_URL.'pic_rights_on.gif" alt="'.__('switch rights on').'" title="'.__('switch rights on').'">';
    $right_all_on  = '<img src="'.SKIN_URL.'pic_rights_all_on.gif" alt="'.__('switch all rights on').'" title="'.__('switch all rights on').'">';
    $right_all_off = '<img src="'.SKIN_URL.'pic_rights_all_off.gif" alt="'.__('switch all rights off').'" title="'.__('switch all rights off').'">';
    $right_active_on  = '<img src="'.SKIN_URL.'pic_rights_active_off.gif" alt="'.__('deactivate').'" title="'.__('deactivate').'">';
    $right_active_off = '<img src="'.SKIN_URL.'pic_rights_active_on.gif" alt="'.__('activate').'" title="'.__('activate').'">';

    echo '<table class="ruler" style="width: 80%">';
    echo '<thead><tr>';
    echo '<th style="width: 40%;"><span>'.__('User').'</span></th>';
    echo '<th style="width: 10%;"><span>'.__('Active').'</span></th>';
    echo '<th style="width: 10%;"><span>'.__('Create & change').'</span></th>';
    echo '<th style="width: 10%;"><span>'.__('Supervise').'</span></th>';
    echo '<th style="width: 10%;"><span>'.__('Global').'</span></th>';
    echo '</tr></thead><tbody>';

    if ($pos=='') $pos = 0;

    $query = "SELECT id, user, name, admin FROM ".CPO_USER." "
            ."WHERE admin>0 "
            .'AND id>=0 '
            ."ORDER BY user ";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);

    while($db->next_record()) {
        $rights = $activeModules['Bilderalbum']['rights'][$db->v('id')];
        
        // Der User
        echo '<tr>';
        printf('<td>%s</td>', 
            htmlspecialchars(formatUserName($db->v('id'), $db->v('user'), $db->v('name')), ENT_COMPAT, 'ISO-8859-15')
        );

        // Aktiv
        $permission_id = '';
        $s1 = 0; $s2 = 0;
        $s3 = 0; $s4 = 0;
        $statusall = '000';

        $_status = '100';
        $icon   = 'pic_rights_active_on.gif';
        $caption = __('activate');

        $permission_id = $db->v('id');

        if ($rights != '') $statusall = $rights;
        
        if ($rights{0} == "1")  {
            $_status = '000';
            $icon   = 'pic_rights_active_off.gif';
            $caption = __('deactivate');
        }
        $link = $_SERVER['PHP_SELF'].'?list=rights&'
               .'bilderalbum_user_id='.$db->v('id').'&';

        echo '<td>';
        if ($_SESSION['SID_user']['admin']<$db->v('admin')) { 
            printIcon($link.'set='.$_status, SKIN_URL.$icon, __('You are not allowed to change the rights of a higher role.'), false);
        } else {
            printIcon($link.'set='.$_status, SKIN_URL.$icon, $caption, true);
        }
        echo '</td>';
        
        // alle anderen Rechte
        for ($i=1; $i<strlen($statusall); $i++) {
            echo '<td>';
            $statusnew = $statusall;
            if ($statusall{$i}=='1') {
                $statusnew{$i} = '0';
                $icon = 'pic_rights_off.gif';
                $caption = __('switch rights off');
            } else {
                $statusnew{$i} = '1';
                $icon = 'pic_rights_on.gif';
                $caption = __('switch rights on');
            }
            if ($_SESSION['SID_user']['admin']<$db->v('admin')) { 
                printIcon($link.'set='.$statusnew, SKIN_URL.$icon, __('You are not allowed to change the rights of a higher role.'), false);
            } else {
                printIcon($link.'set='.$statusnew, SKIN_URL.$icon, $caption, true);
            }
            echo '</td>';
        }
        
        // Global
        echo '<td>';
        if ($_SESSION['SID_user']['admin']<$db->v('admin')) { 
            printIcon($link.'set=000', SKIN_URL.'pic_rights_all_off.gif', __('You are not allowed to change the rights of a higher role.'), false);
            printIcon($link.'set=111', SKIN_URL.'pic_rights_all_on.gif', __('You are not allowed to change the rights of a higher role.'), false);
        } else {
            printIcon($link.'set=000', SKIN_URL.'pic_rights_all_off.gif', __('switch all rights off'), true);
            printIcon($link.'set=111', SKIN_URL.'pic_rights_all_on.gif', __('switch all rights on'), true);
        }
        echo '</td>';
        echo '</tr>';
    } 
    echo '</table>';
}
?>