<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;

// ein paar Warnmeldungen
if ($activeModules['Bilderalbum']['size_message'] == 'yes')  {
	$message[] = sprintf(__('Remember the minimum requirements for the original pictures to be included into the slideshow.<br />Minimum size is set to <b>%s</b> Pixels (either width or height).<br />Only JPG-pictures allowed!<br />The maximum file size is set by Con<i>Presso</i> to <b>%s</b>.'), $activeModules['Bilderalbum']['min_size'], printhumanreadable($cpoSystem['max_image']));
}
require(CPO_BASEDIR."_include/message.php");
?>
<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" enctype="multipart/form-data">
	<input type="hidden" name="files" value="1"> 
	<input type="hidden" name="album" value="<?php echo htmlspecialchars($edit, ENT_COMPAT, 'ISO-8859-15'); ?>"> 
	<input type="hidden" name="edit" value="<?php echo htmlspecialchars($edit, ENT_COMPAT, 'ISO-8859-15'); ?>"> 
	<input type="hidden" name="cols" value="<?php echo $cols; ?>"> 
	<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $System_max_file; ?>">
	<table class="colored" style="width: 100%;">
		<thead>
			<tr>
				<th colspan="2"><span><?php echo __('Picture upload');?></span></th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td colspan="2"><?php echo __('Please remember to upload only JPG-Files!'); ?></td>
			</tr>
        <?php for ($a = 1; $a <= $cpoSystem['noOfUploadFiles']; $a++) { ?>
            <tr>
				<td class="leftrow"><?php echo __('Picture file:'); ?></td><td class="rightrow"><input type="file" name="uppedFiles[]" class="inputwidth"></td>
			</tr>
			<tr>
				<td><?php echo __('Picture description:'); ?></td><td><input class="text inputwidth" type="text" name="beschreibung[]"></td>
			</tr>
        <?php } ?>
			<tr>
				<td class="leftrow"> </td>
				<td class="rightrow"><input type="submit" value="<?php echo __('Upload all pictures'); ?>"></td>
			</tr>
		</tbody>
	</table>
</form>
<form action="process.php" method="post">
	<table class="colored" style="width: 100%;">
		<thead>
			<tr>
				<th colspan="2"><span><?php echo __('Processing FTP directory');?></span></th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td class="leftrow"><?php echo __('Upload directory:'); ?></td>
				<td class="rightrow">
					<?php
						$image_files = listImageFiles("upload");
						if (count($image_files) < 1) {
							$disabled = 'disabled="disabled"';
						}
						if (license($activeModules['Bilderalbum']['lkey'],4) != 1 && license($activeModules['Bilderalbum']['lkey'],4) != 3) {
							$disabled = 'disabled="disabled"';
							$pro_hint = '<br /><img src="../_skin/conpresso/sym_info.gif"> '.__('You need to have a commercial version for this feature!');
						}
					?>
					<input type="hidden" name="process_directory" value="1"> 
					<input type="hidden" name="mode" value="staggered"> 
					<input type="hidden" name="album" value="<?php echo htmlspecialchars($edit, ENT_COMPAT, 'ISO-8859-15'); ?>"> 
					<input type="hidden" name="edit" value="<?php echo htmlspecialchars($edit, ENT_COMPAT, 'ISO-8859-15'); ?>"> 
					<input type="hidden" name="cols" value="<?php echo $cols; ?>"> 
					<input class="i" type="submit" value="<?php echo __('Process'); ?>"<?php echo $disabled; ?>'>
					<?php
						echo sprintf(__('(There are currently <b>%s</b> files in the upload directory <i>%s</i>)'), count($image_files), $activeModules['Bilderalbum']['directory']."/upload/").$pro_hint;
					?>
				</td>
			</tr>
		</tbody>
	</table>
</form>
