<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

global $gallerybreak, $mod_galery_albums, $activeModules, $_params;

$modGalleryPeepString = '';

$linktoimage_string = $activeModules['Bilderalbum']['linktoimage_string'];
$linktoalbum_string = $activeModules['Bilderalbum']['linktoalbum_string'];

$funcparameters = array();
foreach (explode(';', $_params) as $value) {
	if (substr($value, -1)=='\\') {
		$prefix .= substr($value, 0, -1).';';
		continue;
	}
	$value = trim($prefix.$value);
	$prefix = '';
	if ($value=='') continue;

	// split 'a = b' or only 'a'
	preg_match('/\s*([^=]*)\s*(=(.*))?/', $value, $tmp);

	// no matches found?
	if (count($tmp)==0) continue;

	if (count($tmp)==2) { // only a flag
		$funcparameters[strtolower(trim($tmp[1]))] = true;
	}
	if (count($tmp)==4) { // a = b
		$funcparameters[strtolower(trim($tmp[1]))] = trim($tmp[3]);
	}
}

if (array_key_exists('number', $funcparameters)) {
	$imagecount = $funcparameters['number'];
}
if (array_key_exists('link', $funcparameters)) {
	switch (strtolower(trim($funcparameters['link']))) {
		case 'album':
			$peeplinkto = $linktoalbum_string;
			break;
		case 'image':
		default:
			$peeplinkto = $linktoimage_string;
			break;
	}
}
if (array_key_exists('format', $funcparameters)) {
	switch (strtolower(trim($funcparameters['format']))) {
		case 'portrait':
			$formatSQL = 'AND (height / width >= 1)';
			break;
		case 'landscape':
			$formatSQL = 'AND (height / width <= 1)';
			break;
		default:
			$formatSQL = '';
			break;
	}
}

$desc = array();
$pics = array();

// find out if there's any member-gallery otherwise show the non-member-galleries
$membergalleries = FALSE;
    foreach ($mod_galery_albums AS $gkey => $gval)  {
    if (substr($gkey, (strlen($activeModules['Bilderalbum']['member_suffix'])*-1) ) == $activeModules['Bilderalbum']['member_suffix'] ) $membergalleries = TRUE;
}

$memberSQL = " AND RIGHT(album,".strlen($activeModules['Bilderalbum']['member_suffix']).") ". ((!empty($_SESSION['SID_log_login_id']) && $membergalleries) ? '=' : '!=') ." '".$activeModules['Bilderalbum']['member_suffix']."' ";

// Bilder einlesen
	$query = "SELECT datei, album, width, height, beschreibung FROM ".CPO_MOD_GALLERY." WHERE datei <> '' ".$memberSQL.$formatSQL." ";
	$dbpeep = new DB;
    $dbpeep->query($query);
	$anzahl = $dbpeep->num_rows(); // soviel Bilder haben wir

	if (!isset($imagecount)) $imagecount = $anzahl;

	while($dbpeep->next_record()):
		$pics[] = array(
			'pic' => substr($dbpeep->v("datei"),1),
			'album' => htmlspecialchars($dbpeep->v("album"), ENT_COMPAT, 'ISO-8859-15'),
			'width' => $dbpeep->v("width"),
			'height' => $dbpeep->v("height"),
			'beschreibung' => htmlspecialchars($dbpeep->v("beschreibung"), ENT_COMPAT, 'ISO-8859-15')
		);
	endwhile;

	$rand_pic = array();

	for ($x=0;$x<min($imagecount,$anzahl);$x++)
	{
		$rand = rand ( 0, $anzahl-1 );
		if (!in_array($rand,$rand_pic)) 
		{
			$rand_pic[] = $rand;
		}
		else
		{
			$x--;
		}
	}
	
	foreach ($rand_pic as $value)
	{
		$original_file = CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/bilder/h'.$pics[$value]['pic'];
		if (!file_exists($original_file)) continue;
		$dim = @getimagesize($original_file);
		$modGalleryPeepString .= 
			sprintf(
				$peeplinkto, 
				BASE_ABS.$activeModules['Bilderalbum']['directory'],
				$pics[$value]['pic'],
				$dim[0],
				$dim[1],
				($mod_galery_albums[$pics[$value]['album']]['beschreibung']) ? "\n".addslashes($mod_galery_albums[$pics[$value]['album']]['beschreibung']) : '',
				$pics[$value]['album'],
				$activeModules['Bilderalbum']['pop_up_width'],
				$activeModules['Bilderalbum']['pop_up_height'],
				($pics[$value]['beschreibung']) ? "\n".addslashes($pics[$value]['beschreibung']) : ''
				);
	}
    $modGalleryPeepString .= '<script type="text/javascript" src="../mod_gallery/js/ZoomImage.js"></script>'."\n";

?>