<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;
global $CPO;

// Bilderalbum-Tabelle erzeugen
$query = "CREATE TABLE IF NOT EXISTS ".CPO_MOD_GALLERY." (
  id int(10) unsigned NOT NULL auto_increment,
  beschreibung text NOT NULL,
  datei varchar(100) NOT NULL default '',
  size int(11) unsigned NOT NULL default '0',
  width smallint(5) unsigned NOT NULL default '0',
  height smallint(5) unsigned NOT NULL default '0',
  `user` varchar(50) NOT NULL default '',
  album varchar(50) NOT NULL default '',
  `timestamp` timestamp NOT NULL,
  sort int(11) default NULL,
  PRIMARY KEY (id) ) ";
$db->query($query);

// Final messages
$GLOBALS['message'][] = __('The gallery-module was successfully installed!');

// STEP 1. install templates
$cart_template_ids = array();

$filenames = array();
$filenames['article_template'] = 'Template.[mod_gallery].sql.txt';
if (version_compare($CPO['version'], '4.1.0') >= 0) $filenames['page_template'] = 'PageTemplate.[mod_gallery].sql.txt';

foreach ($filenames AS $template_key => $filename)  {
	$sqllines = file(CPO_BASEDIR.'mod_gallery/templates/'.$filename);

	$dbm = new DB;
	$template_id = 0;
	// Durchgehen des Arrays und Anzeigen des HTML-Quelltexts inkl. Zeilennummern
	foreach ($sqllines as $sqlline_num => $sqlline) {
		if (strpos($sqlline,'###CPO_TEMPLATES_CTIME###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_CTIME###',date('Y-m-d H:i:s'),$sqlline);
		if (strpos($sqlline,'###CPO_TEMPLATES_CHANGER###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_CHANGER###',addslashes($_SESSION['SID_login']).' [mod_gallery SETUP]',$sqlline);
		if (strpos($sqlline,'###CPO_TEMPLATES###') !== false) {
			$sqlline = str_replace('###CPO_TEMPLATES###',$dbPrefix.'_templates',$sqlline);
			$dbm->query($sqlline);
			// anschlieend die Nummer des Templates ermiteln
			$query = 'SELECT last_insert_id()';
			$dbm->query($query); 
			$dbm->next_record();
			$template_id = $dbm->v('last_insert_id()');
			continue;
		}
		// Pagetemplates
		if (strpos($sqlline,'###CPO_PAGETEMPLATES_USERID###') !== false) $sqlline = str_replace('###CPO_PAGETEMPLATES_USERID###',addslashes($_SESSION['SID_user']['id']),$sqlline);
		if (strpos($sqlline,'###CPO_PAGETEMPLATES_SAVED###') !== false) $sqlline = str_replace('###CPO_PAGETEMPLATES_SAVED###',date('Y-m-d H:i:s'),$sqlline);
		if (strpos($sqlline,'###CPO_PAGETEMPLATES###') !== false) {
			$sqlline = str_replace('###CPO_PAGETEMPLATES###',$dbPrefix.'_pagetemplates',$sqlline);
			$dbm->query($sqlline);
			// anschlieend die Nummer des Templates ermiteln
			$query = 'SELECT last_insert_id()';
			$dbm->query($query); 
			$dbm->next_record();
			$template_id = $dbm->v('last_insert_id()');
			continue;
		}
		// Placeholders
		if (strpos($sqlline,'###CPO_PLACEHOLDERS###') !== false) $sqlline = str_replace('###CPO_PLACEHOLDERS###',$dbPrefix.'_placeholders',$sqlline);
		if (strpos($sqlline,'###CPO_TEMPLATES_ID###') !== false) $sqlline = str_replace('###CPO_TEMPLATES_ID###',$template_id,$sqlline);
		$dbm->query($sqlline);
	}
	$GLOBALS['message'][] = sprintf(__('The template file <em>%s</em> was saved as a new template.'),$filename);
}

?>