<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

if (!defined('CPO')) exit;


if(!function_exists('listImageFiles')) {
	function listImageFiles($dir)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND strtolower(substr($file,-4)) != ".php")  {
				$image_files[] = $file;
			}
		}
		closedir($h);
		return $image_files;
	}
}

if (!function_exists('listTTFfiles'))  {
	function listTTFfiles($dir)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND strtolower(substr($file,-4)) == ".ttf")  {
				$ttffiles[] = $file;
			}
		}
		closedir($h);
		return $ttffiles;
	}
}

if(!function_exists('reset_bilderalbum_values')) {
	function reset_bilderalbum_values($key, $value, $name)  {
		$GLOBALS['message'][] = sprintf(__('Your input <i>%s</i> is not a valid value for "%s", so "%s" was reset to its previous value!'), $value, $name, $name);
		$GLOBALS['message'][] = __('Some values will not changeable if you have not put in a valid license code!');
		unset ($_POST['cpoBilderalbumNew'][$key]);
	}
}

if(!function_exists('empty_bilderalbum_values')) {
	function empty_bilderalbum_values($name)  {
		$GLOBALS['message'][] = sprintf(__('You need to put in a value for "%s"!'), $name);
		return TRUE;
	}
}

if(!function_exists('check_settings_slideshow')) {
	function check_settings_slideshow($new, $active)  {
		if ($new['quality'] == '' || !is_numeric($new['quality']) || $new['quality'] < 1 || $new['quality'] > 100)
			reset_bilderalbum_values('quality',$_POST['cpoBilderalbumNew']['quality'], __('quality'));
		if ($new['satzspiegel'] == '' || !is_numeric($new['satzspiegel'])) 
			reset_bilderalbum_values('satzspiegel',$_POST['cpoBilderalbumNew']['satzspiegel'], __('type area'));
		if ($new['min_size'] == '' || !is_numeric($new['min_size'])) 
			reset_bilderalbum_values('min_size',$_POST['cpoBilderalbumNew']['min_size'], __('minimum upload picture size'));
		if ($new['max_height'] == '' || !is_numeric($new['max_height'])) 
			reset_bilderalbum_values('max_height',$_POST['cpoBilderalbumNew']['max_height'], __('picture height'));
		if ($new['max_width'] == '' || !is_numeric($new['max_width'])) 
			reset_bilderalbum_values('max_height',$_POST['cpoBilderalbumNew']['max_width'], __('picture width'));
		if ($new['album_rows'] == '' || !is_numeric($new['album_rows'])) 
			reset_bilderalbum_values('album_rows',$_POST['cpoBilderalbumNew']['album_rows'], __('album rows'));
		if ($new['default_cols'] == '' || !is_numeric($new['default_cols'])) 
			reset_bilderalbum_values('default_cols',$_POST['cpoBilderalbumNew']['default_cols'], __('default columns'));
		if ($new['image_size'] == '' || !is_numeric($new['image_size'])) 
			reset_bilderalbum_values('image_size',$_POST['cpoBilderalbumNew']['image_size'], __('image size'));
		if ($new['num_images'] == '' || !is_numeric($new['num_images'])) 
			reset_bilderalbum_values('num_images',$_POST['cpoBilderalbumNew']['num_images'], __('images per page'));
		if ($new['pop_up_width'] == '' || !is_numeric($new['pop_up_width'])) 
			reset_bilderalbum_values('pop_up_width',$_POST['cpoBilderalbumNew']['pop_up_width'], __('pop-up width'));
		if ($new['pop_up_height'] == '' || !is_numeric($new['pop_up_height'])) 
			reset_bilderalbum_values('pop_up_height',$_POST['cpoBilderalbumNew']['pop_up_height'], __('pop-up height'));
		if ($new['slide_frame'] == '' || !is_numeric($new['slide_frame'])) 
			reset_bilderalbum_values('slide_frame',$_POST['cpoBilderalbumNew']['slide_frame'], __('slide_frame'));
		if ($new['padding'] == '' || !is_numeric($new['padding'])) 
			reset_bilderalbum_values('padding',$_POST['cpoBilderalbumNew']['padding'], __('padding'));
	}
}

if(!function_exists('slideshow_thumbnail')) {
	function slideshow_thumbnail($filename, $thumbsize, $save_to, $quality)  {

		$imagefile = ImageCreateFromJPEG($filename);
		$breite = imagesx($imagefile);
		$hoehe = imagesy($imagefile);
	//Hochformat
		if ( $breite >= $hoehe )  {
			$thumbbreite = $thumbsize;
			$faktor = $breite / $thumbbreite;
			$thumbhoehe = ceil ($hoehe / $faktor);
		}
	//Querformat
		if ( $breite < $hoehe )  {
			$thumbhoehe = $thumbsize;
			$faktor = $hoehe / $thumbhoehe;
			$thumbbreite = ceil ($breite / $faktor);
		}
		$thumb = imagecreatetruecolor($thumbbreite, $thumbhoehe);
		imagecopyresampled($thumb, $imagefile, 0, 0, 0, 0, $thumbbreite, $thumbhoehe, $breite, $hoehe);
	// Saving & Cleaning
		imagejpeg($thumb, $save_to, $quality);
		imagedestroy($imagefile);
		imagedestroy($thumb);
	}
}

if(!function_exists('slideshow_picture')) {
	function slideshow_picture($filename, $max_width, $max_height, $save_to, $quality)  {

		$imagefile = ImageCreateFromJPEG($filename);
		$breite = imagesx($imagefile);
		$hoehe = imagesy($imagefile);
	//Querformat
		if ( $breite >= $hoehe )  {
			$standardbreite = $max_width;
			$faktor = $breite / $max_width;
			$standardhoehe = ceil ($hoehe / $faktor);
		}
	//Hochformat
		if ( $breite < $hoehe )  {
			$standardhoehe = $max_height;
			$faktor = $hoehe / $max_height;
			$standardbreite = ceil ($breite / $faktor);
		}
	//bei berhhe > $max_height
		if ($standardhoehe > $max_height)  {
			$standardhoehe = $max_height;
			$standardbreite = ceil ($standardhoehe * ($breite/$hoehe));
		}
		$bild = imagecreatetruecolor($standardbreite, $standardhoehe);
		imagecopyresampled($bild, $imagefile, 0, 0, 0, 0, $standardbreite, $standardhoehe, $breite, $hoehe);
	// watermark & copyright
		if (function_exists('watermark_copyright')) $bild = watermark_copyright($bild);
	// Saving & Cleaning
		imagejpeg($bild, $save_to, $quality);
		imagedestroy($imagefile);
		imagedestroy($bild);
	}
}

if(!function_exists('save_modulesettings')) {
	function save_modulesettings($new_array, $active_array)  {
		global $activeModules;
		$new_settings = $_POST;
		foreach ($activeModules[$active_array] as $k=>$v) {
			if (!isset($_POST[$new_array][$k])) continue;
			if (is_bool($activeModules[$active_array][$k])) {
				$activeModules[$active_array][$k] = (bool) $_POST[$new_array][$k];
			}
			else $activeModules[$active_array][$k] = $_POST[$new_array][$k];
			if (array_key_exists($k, $new_settings[$new_array])) unset($new_settings[$new_array][$k]);
		}
		if (is_array($new_settings[$new_array]))
		{
			foreach ($new_settings[$new_array] as $k=>$v) {
				$activeModules[$active_array][$k] = $new_settings[$new_array][$k];
			}
		}
		$query = sprintf(
				 "UPDATE ".CPO_MODULES." SET options ="
				." '%s' WHERE name = '".$active_array."'", 
				addslashes(serialize($activeModules[$active_array]))
		);
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query); 
		$GLOBALS['message'][] = __('Module settings were updated!');   
	}
}

if (!function_exists('settings_row'))  {
	function settings_row($label, $content)
	{
		echo '<tr>';
            echo '<td class="leftrow">';
            echo $label;
            echo '</td>';
            echo '<td class="rightrow">';
            echo $content;
            echo '</td>';
		echo '</tr>';

	}
}

if (!function_exists('watermark_copyright'))  {
	function watermark_copyright($bild)  {
		global $activeModules;
		if ($activeModules['Bilderalbum']['mark_copyright'] == 'yes' || $activeModules['Bilderalbum']['show_watermark'] == 'yes')  { 

			// PRO-Values
			$watermark_pic				= CPO_BASEDIR.$activeModules['Bilderalbum']['directory'] . '/' . $activeModules['Bilderalbum']['watermark_pic'];
			$watermark_scale			= $activeModules['Bilderalbum']['watermark_scale'];
			$watermark_transparency		= $activeModules['Bilderalbum']['watermark_transparency'];
			$copyright_border			= $activeModules['Bilderalbum']['copyright_border'];

			$imageTypes = array(
				'unknown', 
				'GIF', 
				'JPG', 
				'PNG'
			);

			$standardbreite = imagesx($bild); 
			$standardhoehe = imagesy($bild); 
			imagealphablending($bild,true);

			if ($activeModules['Bilderalbum']['show_watermark'] == 'yes')  { 
				// watermark
				$logo_type = getimagesize ( $watermark_pic );
				if ($imageTypes[$logo_type[2]]=='JPG')  $insert = imagecreatefromjpeg($watermark_pic); 
				if ($imageTypes[$logo_type[2]]=='GIF')  $insert = imagecreatefromgif($watermark_pic); 
				if ($imageTypes[$logo_type[2]]=='PNG')  $insert = imagecreatefrompng($watermark_pic); 
				$insert_x = imagesx($insert); 
				$insert_y = imagesy($insert); 

				if ($watermark_scale == 'yes')  {  // Wasserzeichen dehnen
				// Logo skalieren
					$logo = imagecreatetruecolor($standardbreite, $standardhoehe);
					$back = imagecolorallocate($logo, 200,200,200); 
					imagefilledrectangle($logo, 0, 0, $standardbreite, $standardhoehe, $back);
					imagecolortransparent($logo, $back);
					if ($imageTypes[$logo_type[2]]=='PNG') {
						imageAlphaBlending($logo, false); //PNG false
						imagecopyresampled($logo, $insert, 0, 0, 0, 0, $standardbreite, $standardhoehe, $insert_x, $insert_y);
						imagecopymerge_alpha($bild, $logo, 0, 0, 0, 0, $standardbreite, $standardhoehe, $watermark_transparency);  // works best with PNG
					} else {
						imageAlphaBlending($logo, true); //GIF,JPG true
						imagecopyresampled($logo, $insert, 0, 0, 0, 0, $standardbreite, $standardhoehe, $insert_x, $insert_y);
						imagecopymerge($bild, $logo, 0, 0, 0, 0, $standardbreite, $standardhoehe, $watermark_transparency); // works best with GIF,JPG
					}
				} else {
					$logo = $insert;
					// Position bestimmen
					switch ($activeModules['Bilderalbum']['watermark_pos'])  {
						case 1: $watermark_align = "left"; $watermark_valign = "top"; break;
						case 2: $watermark_align = "center"; $watermark_valign = "top"; break;
						case 3: $watermark_align = "right"; $watermark_valign = "top"; break;
						case 4: $watermark_align = "left"; $watermark_valign = "middle"; break;
						case 5: $watermark_align = "center"; $watermark_valign = "middle"; break;
						case 6: $watermark_align = "right"; $watermark_valign = "middle"; break;
						case 7: $watermark_align = "left"; $watermark_valign = "bottom"; break;
						case 8: $watermark_align = "center"; $watermark_valign = "bottom"; break;
						case 9: $watermark_align = "right"; $watermark_valign = "bottom"; break;
					}
					if ($watermark_align == "left")		$watermark_x = 0;
					if ($watermark_align == "center")	$watermark_x = $standardbreite / 2 - $insert_x / 2;
					if ($watermark_align == "right")	$watermark_x = $standardbreite - $insert_x;
					if ($watermark_valign == "top")		$watermark_y = 0;
					if ($watermark_valign == "middle")	$watermark_y = $standardhoehe / 2 - $insert_y / 2;
					if ($watermark_valign == "bottom")	$watermark_y = $standardhoehe - $insert_y ;

					if ($imageTypes[$logo_type[2]]=='PNG') imagecopymerge_alpha($bild, $logo, $watermark_x, $watermark_y, 0, 0, $insert_x, $insert_y, $watermark_transparency);  // works best with PNG
					else imagecopymerge($bild, $logo, $watermark_x, $watermark_y, 0, 0, $insert_x, $insert_y, $watermark_transparency); // works best with GIF,JPG
				}

				// Ende watermark
			}

			if ($activeModules['Bilderalbum']['mark_copyright'] == 'yes')  { 

				// Copyright
				switch ($activeModules['Bilderalbum']['copyright_pos'])  {
					case 1: $copyright_align = "left"; $copyright_valign = "top"; break;
					case 2: $copyright_align = "center"; $copyright_valign = "top"; break;
					case 3: $copyright_align = "right"; $copyright_valign = "top"; break;
					case 4: $copyright_align = "left"; $copyright_valign = "middle"; break;
					case 5: $copyright_align = "center"; $copyright_valign = "middle"; break;
					case 6: $copyright_align = "right"; $copyright_valign = "middle"; break;
					case 7: $copyright_align = "left"; $copyright_valign = "bottom"; break;
					case 8: $copyright_align = "center"; $copyright_valign = "bottom"; break;
					case 9: $copyright_align = "right"; $copyright_valign = "bottom"; break;
				}
				$text_color = $activeModules['Bilderalbum']['text_color'];
				$r = hexdec(substr($text_color,1,2));
				$g = hexdec(substr($text_color,3,2));
				$b = hexdec(substr($text_color,5,2));
				$text_color = imagecolorallocate ($bild, $r, $g, $b);
				$shadow_color = $activeModules['Bilderalbum']['shadow_color'];
				$r = hexdec(substr($shadow_color,1,2));
				$g = hexdec(substr($shadow_color,3,2));
				$b = hexdec(substr($shadow_color,5,2));
				$shadow_color = imagecolorallocate ($bild, $r, $g, $b);
				$font = CPO_BASEDIR.$activeModules['Bilderalbum']['directory'] . '/' . $activeModules['Bilderalbum']['font'];
				$font_size = $activeModules['Bilderalbum']['font_size'];
				$font_angle = 0;
				$text = $activeModules['Bilderalbum']['copyright_content'];
				$bbox = imagettfbbox ($font_size, $font_angle, $font, $text);
				$textWidth = $bbox[2] - $bbox[0];
				$textHeight = $bbox[1] - $bbox[7];
				if ($copyright_align == "left")		$copyright_x = $copyright_border;
				if ($copyright_align == "center")	$copyright_x = $standardbreite / 2 - $textWidth / 2;
				if ($copyright_align == "right")	$copyright_x = $standardbreite - $textWidth - $copyright_border;
				if ($copyright_valign == "top")		$copyright_y = $copyright_border + $textHeight;
				if ($copyright_valign == "middle")	$copyright_y = $standardhoehe / 2 + $textHeight / 2;
				if ($copyright_valign == "bottom")	$copyright_y = $standardhoehe - $copyright_border ;
				imagettftext ($bild, $font_size, $font_angle, $copyright_x+1 , $copyright_y+1, $shadow_color, $font, $text);
				imagettftext ($bild, $font_size, $font_angle, $copyright_x, $copyright_y, $text_color, $font, $text);
				// Ende Copyright
			}
		}
		return $bild;
	}
}


if (!function_exists('greyscale'))  {
	function greyscale($image,$type)  {
		global $activeModules;
		if ($activeModules['Bilderalbum']['watermark_mode'] == 'greyscale' && $type != 1) {
			$img_width = imagesx($image); 
			$img_height = imagesy($image); 
			for ($y = 0; $y <$img_height; $y++) {
				for ($x = 0; $x <$img_width; $x++) { 
				$rgb = ImageColorAt($image, $x, $y);
				$red = ($rgb >> 16) & 0xFF;
				$green = (trgb >> 8) & 0xFF;
				$blue = $rgb & 0xFF;
				$gray = (int)(($red+$green+$blue)/4); 
				imagesetpixel ($image, $x, $y, ImageColorAllocate ($image, $gray,$gray,$gray));
				}
			}
		}
		return $image;
	}
}

if (!function_exists('imagecopymerge_alpha'))  {
	/** 
	 * PNG ALPHA CHANNEL SUPPORT for imagecopymerge(); 
	 * This is a function like imagecopymerge but it handle alpha channel well!!! 
	 **/ 

	// A fix to get a function like imagecopymerge WITH ALPHA SUPPORT 
	// Main script by aiden dot mail at freemail dot hu 
	// Transformed to imagecopymerge_alpha() by rodrigo dot polo at gmail dot com 
	function imagecopymerge_alpha($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h, $pct){ 
		if(!isset($pct)){ 
			return false; 
		} 
		$pct /= 100; 
		// Get image width and height 
		$w = imagesx( $src_im ); 
		$h = imagesy( $src_im ); 
		// Turn alpha blending off 
		imagealphablending( $src_im, false ); 
		// Find the most opaque pixel in the image (the one with the smallest alpha value) 
		$minalpha = 127; 
		for( $x = 0; $x < $w; $x++ ) 
		for( $y = 0; $y < $h; $y++ ){ 
			$alpha = ( imagecolorat( $src_im, $x, $y ) >> 24 ) & 0xFF; 
			if( $alpha < $minalpha ){ 
				$minalpha = $alpha; 
			} 
		} 
		//loop through image pixels and modify alpha for each 
		for( $x = 0; $x < $w; $x++ ){ 
			for( $y = 0; $y < $h; $y++ ){ 
				//get current alpha value (represents the TANSPARENCY!) 
				$colorxy = imagecolorat( $src_im, $x, $y ); 
				$alpha = ( $colorxy >> 24 ) & 0xFF; 
				//calculate new alpha 
				if( $minalpha !== 127 ){ 
					$alpha = 127 + 127 * $pct * ( $alpha - 127 ) / ( 127 - $minalpha ); 
				} else { 
					$alpha += 127 * $pct; 
				} 
				//get the color index with new alpha 
				$alphacolorxy = imagecolorallocatealpha( $src_im, ( $colorxy >> 16 ) & 0xFF, ( $colorxy >> 8 ) & 0xFF, $colorxy & 0xFF, $alpha ); 
				//set pixel with the new color + opacity 
				if( !imagesetpixel( $src_im, $x, $y, $alphacolorxy ) ){ 
					return false; 
				} 
			} 
		} 
		// The image copy 
		imagecopy($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h); 
	} 
}

if (!function_exists('boxHeader'))  {
	function boxHeader($name, $text, $display)  {
		// the initial setting
		if ($display === false)  {
			$visibility = ' style="display:none"';
			$linkText = '<img src="'.SKIN_URL.'nav_open.gif"> '.__('show');
			$linkIcon = '<img src="'.SKIN_URL.'nav_open.gif" id="'.$name.'icon"> ';
		} else {
			$visibility = '';
			$linkText = '<img src="'.SKIN_URL.'nav_close.gif"> '.__('hide');
			$linkIcon = '<img src="'.SKIN_URL.'nav_close.gif" id="'.$name.'icon"> ';
		}
		// override with the chosen setting
		if ($_COOKIE[$name] == 'false')  {
			$visibility = ' style="display:none"';
			$linkText = '<img src="'.SKIN_URL.'nav_open.gif"> '.__('show');
			$linkIcon = '<img src="'.SKIN_URL.'nav_open.gif" id="'.$name.'icon"> ';
		} else if ($_COOKIE[$name] == 'true') {
			$visibility = '';
			$linkText = '<img src="'.SKIN_URL.'nav_close.gif"> '.__('hide');
			$linkIcon = '<img src="'.SKIN_URL.'nav_close.gif" id="'.$name.'icon"> ';
		}
		echo '<table class="colored" style="width: 100%;"><thead><tr><th><span><a href="#" onClick="ausblenden(\''.$name.'\', \''.$name.'link\');return false">' . $linkIcon . $text . '</a></span></th><th style="text-align:right !important;"><span><a href="#" onClick="ausblenden(\''.$name.'\',\''.$name.'link\');return false" id="'.$name.'link">'.$linkText.'</a></span></th></tr></thead><tbody id="'.$name.'"'.$visibility.'>';
	}
}

if (!function_exists('bilderalbum_process'))  {
	function bilderalbum_process($act, $total)  {
		$filled = (int) (min(100,($act/$total)*100));
		$unfilled = (int) (($total-$act)*100);
		echo '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td width="5%">';
		echo "0%&nbsp;&nbsp;";
		echo '</td><td width="90%">';
		echo '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>';
		echo '<td width="'.$filled.'%" style="background-color: #ffa800 !important; text-align: right;"><font color="#FFFFFF">&nbsp;<b>'.$filled.'%</b>&nbsp;</font></td>';
		echo '<td width="'.$unfilled.'%">&nbsp;</td>';
		echo '</tr></table>';
		echo '</td><td width="5%">';
		echo "&nbsp;&nbsp;100%";
		echo '</td></tr></table>';
	}
}

if (!function_exists('bilderalbum_sort'))  {
	function bilderalbum_sort($id, $sort_id, $type='pic')  {
		global $offset, $album, $total, $cols;
		$state_up = ($_GET['id']==$id && ($_GET['action']=='up' || $_GET['action']=='rew' || $_GET['action']=='top')) ? '2' : '';
		$state_down = ($_GET['id']==$id && ($_GET['action']=='down' || $_GET['action']=='ff' || $_GET['action']=='bottom')) ? '2' : '';
		$hash=md5(microtime());
		$href=htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15');
		$albumname=htmlspecialchars($album, ENT_COMPAT, 'ISO-8859-15');

		$url = ( $type=='pic') ? 
			'<a href="%1$s?id=%2$s&amp;action=%3$s&amp;type=%4$s&amp;cols='.$cols.'&amp;edit=%5$s&amp;hash='.$hash.'#id%2$s">' :
			'<a href="%1$s?id=%2$s&amp;action=%3$s&amp;type=%4$s&amp;cols='.$cols.'hash='.$hash.'#id%2$s">';

		if ($sort_id == 1)  { // first one
			$empty_up = '<img src="'.GAL_SKIN_URL.'sort_empty'.$state_up.'.gif" style="margin: 0 2px 2px 0; border: none;">';
			echo $empty_up.$empty_up.$empty_up.'<br>';
		} else {
			printf($url, $href, $id, 'up', $type, $albumname);
			print('<img src="'.GAL_SKIN_URL.'sort_up'.$state_up.'.gif" style="margin: 0 2px 2px 0; border: none;" alt="'.___('move up').'" title="'.___('move up').'" /></a>');
			
			printf($url, $href, $id, 'rew', $type, $albumname);
			print('<img src="'.GAL_SKIN_URL.'sort_rew'.$state_up.'.gif" style="margin: 0 2px 2px 0; border: none;" alt="'.$offset.___(' positions up').'" title="'.$offset.___(' positions up').'" /></a>');
			
			printf($url, $href, $id, 'top', $type, $albumname);
			print('<img src="'.GAL_SKIN_URL.'sort_top'.$state_up.'.gif" style="margin: 0 2px 2px 0; border: none;" alt="'.___('move to top').'" title="'.___('move to top').'" /></a><br />');
		}

		if ($sort_id == $total)  { // last one
			$empty_down = '<img src="'.GAL_SKIN_URL.'sort_empty'.$state_down.'.gif" style="margin: 0 2px 2px 0; border: none;">';
			echo $empty_down.$empty_down.$empty_down;
		} else {
			printf($url, $href, $id, 'down', $type, $albumname);
			print('<img src="'.GAL_SKIN_URL.'sort_down'.$state_down.'.gif" style="margin: 0 2px 2px 0; border: none;" alt="'.___('move down').'" title="'.___('move down').'" /></a>');
			
			printf($url, $href, $id, 'ff', $type, $albumname);
			print('<img src="'.GAL_SKIN_URL.'sort_ff'.$state_down.'.gif" style="margin: 0 2px 2px 0; border: none;" alt="'.$offset.___(' positions down').'" title="'.$offset.___(' positions down').'" /></a>');
			
			printf($url, $href, $id, 'bottom', $type, $albumname);
			print('<img src="'.GAL_SKIN_URL.'sort_bottom'.$state_down.'.gif" style="margin: 0 2px 2px 0; border: none;" alt="'.___('move to bottom').'" title="'.___('move to bottom').'" /></a><br />');
		}
	}
}

if (!function_exists('bilderalbum_resync'))  {
	function bilderalbum_resync($album)  {
		global $dbPrefix;
        $resync = $album;
        $resyncPos = 1;
        $query = "SELECT id FROM ".CPO_MOD_GALLERY." WHERE datei <> '' AND album = '".addslashes($resync)."' ORDER BY sort ";
        DEBUG(2, $query, __FILE__, __LINE__);  
        $db = new DB;
        $db->query($query);
        // Positionen neu durchnummerieren!
        $dbresync = new DB;
        while($db->next_record()):
        $q = "UPDATE ".CPO_MOD_GALLERY." "
            ."SET sort=".$resyncPos++." "
            ."WHERE id=".$db->v('id')." ";
        $dbresync->query($q);
        endwhile;
    }
}
if (!function_exists('alben_resync'))  {
	function alben_resync()  {
		global $dbPrefix;
        $resyncPos = 1;
        $query = "SELECT id FROM ".CPO_MOD_GALLERY." WHERE datei = '' ORDER BY height ";
        DEBUG(2, $query, __FILE__, __LINE__);  
        $db = new DB;
        $db->query($query);
        // Positionen neu durchnummerieren!
        $dbresync = new DB;
        while($db->next_record()):
        $q = "UPDATE ".CPO_MOD_GALLERY." "
            ."SET height=".$resyncPos++." "
            ."WHERE id=".$db->v('id')." ";
        $dbresync->query($q);
        endwhile;
    }
}

if (!function_exists('albumPlaceholder'))  {
	function albumPlaceholder($placeholder)  {
		return '/(<!--|\[!--|###)(\s|&nbsp;)*'.preg_quote($placeholder,'/').'(\s|&nbsp;)*(-->|--\]>|###)/si';
	}
}


if (!function_exists('getAlbumPage'))  {
	function getAlbumPage($show, $page=1)  {

        global $activeModules, $mod_galery_albums, $gallerybreak, $message, $cpoSystem, $db_nr;

 //       return "test";


        require(CPO_BASEDIR."_include/message.php");
        if (!$gallerybreak) {

            // Modulvariablen
                $quality		    = $activeModules['Bilderalbum']['quality'];
                $satzspiegel	    = $activeModules['Bilderalbum']['satzspiegel'];
                $min_size		    = $activeModules['Bilderalbum']['min_size'];
                $max_width		    = $activeModules['Bilderalbum']['max_width'];
                $max_height		    = $activeModules['Bilderalbum']['max_height'];
                $album_height   	= $activeModules['Bilderalbum']['album_height'];
                $pop_up_width	    = $activeModules['Bilderalbum']['pop_up_width'];
                $pop_up_height   	= $activeModules['Bilderalbum']['pop_up_height'];
                $slide_frame	    = $activeModules['Bilderalbum']['slide_frame'];
                $padding		    = $activeModules['Bilderalbum']['padding'];
                $dia_padding	    = $activeModules['Bilderalbum']['dia_padding'];
                $overview_format    = $activeModules['Bilderalbum']['overview_format'];
                $display_navigation = $activeModules['Bilderalbum']['display_navigation'];
                $num_images         = $activeModules['Bilderalbum']['num_images'];
                $image_size         = $activeModules['Bilderalbum']['image_size'];
                $album_rows         = $activeModules['Bilderalbum']['album_rows'];
                if (!$db_nr) $db_nr = 1;

            // ####################################################################################################
            // Bilderalbum anzeigen
            if (isset($_GET['show'])) $show = $_GET['show'];
            if (isset($show))  {

                $detailstring = '';
                foreach ($_GET AS $parm=>$val)  {
                    if ($parm == session_name()) continue;
                    if ($parm == 'album_start') continue;
                    if ($parm == 'album_page') continue;
                    $detailstring .= '&amp;'.$parm.'='.$val;
                }
                $detailstring .= '#'.urlencode($show);
                $album_start_all = $album_start;
                // Spaltenzahl ermitteln
                $cols = $mod_galery_albums[$show]['width'];		
                $beschreibung = $mod_galery_albums[$show]['beschreibung'];		
                // Bilder auslesen
                $query = "SELECT * FROM ".CPO_MOD_GALLERY." WHERE (album = '".addslashes($show)."' AND datei <> '') ORDER BY sort";
                DEBUG(2, $query, __FILE__, __LINE__);  
                $db3 = new DB;
                $db3->query($query);
                if ($db3->num_rows()>0) {

                //*************** Start des Bilderalbums *******************************
                // Bestimmung der Diagre und Grundwerte

                $bilderzahl		= $db3->num_rows();

                if (!isset($_GET['album_start']) OR $_GET['album_page'] != $show) {
                    $album_start = 1;
                } else {
                    $album_start = (int)$_GET['album_start'];
                }

                if ($overview_format == 'table') {
                    $zeilen			= $album_rows;
                    $tablesize		= $satzspiegel;
                    $size			= floor (($satzspiegel - (($cols - 1) * $padding)) / $cols);
                    $thumbsize		= floor ($size - (2 * $slide_frame));
                    $pics_per_page	= $zeilen * $cols;
                    if ($page>=2) $album_start = 1+(($page-1)*$pics_per_page);
                    $album_stop		= $album_start + $zeilen * $cols;
                    $seiten			= ceil($bilderzahl / $pics_per_page);
                }
                if ($overview_format == 'pics') {
                    $thumbsize		= $image_size;
                    $seiten			= ceil($bilderzahl / $num_images);
                    $pics_per_page	= $num_images;
                    if ($page>=2) $album_start = 1+(($page-1)*$pics_per_page);
                    $album_stop		= $album_start + $num_images;
                }

            // ************** Album-Ausgabe ********************
                
                if ($beschreibung != '') $album_description = $beschreibung;

            // ************** die Dia-Tabelle ********************
                if ($overview_format == 'table')
                    {
                    $slide_table = "<table>\n";
                    $pre_table = '';
                    $after_table = '';
                    $col = 0;
                    $bildnummer = 1;
                    // einmaliges Einlesen der Slide-Definition
                    $slide_base_string = ($activeModules['Bilderalbum']['slideshow_format'] == 'lightbox') ?  $activeModules['Bilderalbum']['lightbox_slide_template'] : $activeModules['Bilderalbum']['slide_template'];

                    while($db3->next_record()):

                        $pic = substr($db3->v("datei"),1);
                        $time = $db3->v("timestamp");
                        // YYYYMMDDhhmmss -> unixtime hhmmssMMDDYYYY
                        $time = mktime(substr($time,8,2), substr($time,10,2), substr($time,12,2), substr($time,4,2), substr($time,6,2), substr($time,0,4));
                        $timestring = date($cpoSystem['date_format'],$time);
                        $dim = @getimagesize('bilder/h'.$pic);

                        if ($bildnummer >= $album_start && $bildnummer < $album_stop)  {
                            if ($col % $cols == 0)  {
                                $slide_table .= "<tr>\n";
                                $end_tr = false;
                            }
                            $slide_string = $slide_base_string;

                            $replacer[albumPlaceholder('SLIDE_SIZE')]             = $size;
                            $replacer[albumPlaceholder('INNER_SLIDE_SIZE')]       = $thumbsize;
                            $replacer[albumPlaceholder('ALBUM_PIC')]              = $pic;
                            $replacer[albumPlaceholder('ALBUM_PIC_WIDTH')]        = $dim[0];
                            $replacer[albumPlaceholder('ALBUM_PIC_HEIGHT')]       = $dim[1];
                            $replacer[albumPlaceholder('ALBUM_PIC_ORG_WIDTH')]    = $db3->v("width");
                            $replacer[albumPlaceholder('ALBUM_PIC_ORG_HEIGHT')]   = $db3->v("height");
                            $replacer[albumPlaceholder('ALBUM_PIC_USER')]         = htmlspecialchars($db3->v("user"), ENT_COMPAT, 'ISO-8859-15');
                            $replacer[albumPlaceholder('ALBUM_PIC_TIMESTAMP')]    = $time;
                            $replacer[albumPlaceholder('ALBUM_PIC_DATE')]         = $timestring;
                            $replacer[albumPlaceholder('ALBUM_PIC_SIZE')]         = printHumanReadable($db3->v("size"));
                            $replacer[albumPlaceholder('ALBUM_FROM')]             = urlencode($show);
                            $replacer[albumPlaceholder('ALBUM_THUMB')]            = 't'.$pic;
                            $replacer[albumPlaceholder('ALBUM_PIC_BESCHREIBUNG')] = htmlspecialchars($db3->v("beschreibung"), ENT_QUOTES, 'ISO-8859-15');
                            $replacer[albumPlaceholder('ALBUM_PIC_DESCRIPTION')] = htmlspecialchars($db3->v("beschreibung"), ENT_QUOTES, 'ISO-8859-15');

                            $slide_string = preg_replace(array_keys($replacer), array_values($replacer), $slide_string);
                            $slide_table .= $slide_string;
                            $col++;
                            if ($col < $cols)  {
                                $slide_table .= '<td class="xx"></td>';
                            }
                        }

                        $bildnummer++;
                        if (($col) % $cols == 0 && $col != 0)  {
                            $slide_table .= "</tr><tr><td class=\"xx\" cols=\"".($cols*2-1)."\"></td></tr>\n";
                            $end_tr = true;
                            $col = 0;
                        }
                        
                    endwhile;
                    if (!$end_tr)  {				// wenn nicht schon eine Endzeile wegen voll da ist, machen wir halt jetzt eine
                        for ($x=1;$x<=($cols-$col);$x++)  {
                            // fehlende Zellen letzte Zeile, falls alleine auf der Seite
                            $slide_table .= "<td class=\"slide\">&nbsp;</td>";
                            if ($x<($cols-$col)) $slide_table .= "<td class=\"xx\"></td>";
                        }
                        $slide_table .= "</tr><tr><td class=\"xx\" cols=\"".($cols*2-1)."\"></td></tr>\n";
                    }

                    $slide_table .= "</table>\n";
                }
            // ************** Ende Dia-Tabelle ********************

            // ************** die Dia-Bilder ********************
                if ($overview_format == 'pics')
                    {
                    $bildnummer = 1;
                    // einmaliges Einlesen der Slide-Definition
                    $slide_base_string = ($activeModules['Bilderalbum']['slideshow_format'] == 'lightbox') ?  $activeModules['Bilderalbum']['lightbox_thumb_template'] : $activeModules['Bilderalbum']['thumb_template'];

                    while($db3->next_record()):
                        $slide_string = $slide_base_string;
                        $pic = substr($db3->v("datei"),1);
                        $time = $db3->v("timestamp");
                        // YYYYMMDDhhmmss -> unixtime hhmmssMMDDYYYY
                        $time = mktime(substr($time,8,2), substr($time,10,2), substr($time,12,2), substr($time,4,2), substr($time,6,2), substr($time,0,4));
                        $timestring = date($cpoSystem['date_format'],$time);
                        $dim = @getimagesize('bilder/h'.$pic);

                        if ($bildnummer >= $album_start && $bildnummer < $album_stop)  {

                            $replacer[albumPlaceholder('SLIDE_SIZE')]             = $size;
                            $replacer[albumPlaceholder('INNER_SLIDE_SIZE')]       = $thumbsize;
                            $replacer[albumPlaceholder('ALBUM_PIC')]              = $pic;
                            $replacer[albumPlaceholder('ALBUM_PIC_WIDTH')]        = $dim[0];
                            $replacer[albumPlaceholder('ALBUM_PIC_HEIGHT')]       = $dim[1];
                            $replacer[albumPlaceholder('ALBUM_PIC_ORG_WIDTH')]    = $db3->v("width");
                            $replacer[albumPlaceholder('ALBUM_PIC_ORG_HEIGHT')]   = $db3->v("height");
                            $replacer[albumPlaceholder('ALBUM_PIC_USER')]         = htmlspecialchars($db3->v("user"), ENT_COMPAT, 'ISO-8859-15');
                            $replacer[albumPlaceholder('ALBUM_PIC_TIMESTAMP')]    = $time;
                            $replacer[albumPlaceholder('ALBUM_PIC_DATE')]         = $timestring;
                            $replacer[albumPlaceholder('ALBUM_PIC_SIZE')]         = printHumanReadable($db3->v("size"));
                            $replacer[albumPlaceholder('ALBUM_FROM')]             = urlencode($show);
                            $replacer[albumPlaceholder('ALBUM_THUMB')]            = 't'.$pic;
                            $replacer[albumPlaceholder('ALBUM_PIC_BESCHREIBUNG')] = htmlspecialchars($db3->v("beschreibung"), ENT_QUOTES, 'ISO-8859-15');
                            $replacer[albumPlaceholder('ALBUM_PIC_DESCRIPTION')] = htmlspecialchars($db3->v("beschreibung"), ENT_QUOTES, 'ISO-8859-15');

                            $slide_string = preg_replace(array_keys($replacer), array_values($replacer), $slide_string);
                            $slide_table .= $slide_string;
                        }

                        $bildnummer++;
                    endwhile;
                }
            // ************** Ende Dia-Bilder ********************


            if (($display_navigation == 'auto' && $seiten > 1) || $display_navigation == 'always')
            {	
                // **************** Album-Naviation *********************
                $thisPage = ( ($album_start-1) / $pics_per_page ) + 1;
                // page-rewind
                    $page_rewind = '';
                    if (1 <= $album_start-$pics_per_page)  {
                        $page_rewind = '<a href="' . $_SERVER['PHP_SELF'] . '?album_start=' . ($album_start - $pics_per_page) . '&album_page=' . urlencode($show) . $detailstring . '" onClick="albumPage('.($thisPage-1).','.$db_nr.'); return false;">' . $activeModules['Bilderalbum']['page_rewind'] . '</a>';
                    }
                // pagination
                    $pagination = '';
                    for ($s=0;$s<$seiten;$s++)  {
                        $page_link = $_SERVER['PHP_SELF'] . '?album_start=' . ( 1 + ($s * $pics_per_page)) . '&album_page=' . urlencode($show) . $detailstring . '" onClick="albumPage('.($s+1).','.$db_nr.'); return false;';
                        $page_nr = $s+1;

                        $replacer[albumPlaceholder('PAGE_LINK')] = $page_link;
                        $replacer[albumPlaceholder('PAGE')]      = $page_nr;

                        if ($album_start == ( 1 + ($s * $pics_per_page))) // die aktuelle Seite
                        {
                            $pagination .= preg_replace(array_keys($replacer), array_values($replacer), $activeModules['Bilderalbum']['actual_page']);
                        } else {
                            $pagination .= preg_replace(array_keys($replacer), array_values($replacer), $activeModules['Bilderalbum']['pagination']);
                        }
                        unset($page_nr,$page_link);
                        
                    }
                // page-forward
                    $page_forward = '';
                    if ($bilderzahl >= $album_start+($pics_per_page))  {
                        $page_forward = ' <a href="' . $_SERVER['PHP_SELF'] . '?album_start=' . ($album_start + ($pics_per_page)) . '&album_page=' . urlencode($show) . $detailstring . '" onClick="albumPage('.($thisPage+1).','.$db_nr.'); return false;">' .$activeModules['Bilderalbum']['page_forward'] . '</a>';
                    }
                // album-navigation
                    $replacer[albumPlaceholder('PAGE_REWIND')]  = $page_rewind;
                    $replacer[albumPlaceholder('PAGINATION')]   = $pagination;
                    $replacer[albumPlaceholder('PAGE_FORWARD')] = $page_forward;
                    $album_navigation = preg_replace(array_keys($replacer), array_values($replacer), $activeModules['Bilderalbum']['album_navigation']);
                    unset($page_rewind,$pagination,$page_forward);
                // **************** Album-Naviation End *********************
            }

            // Platzhalter allgemein
                $commonReplacer = array();
                $commonReplacer[albumPlaceholder('ARTICLE_NR')]        = $db_nr;
                $commonReplacer[albumPlaceholder('SLIDE_PADDING')]     = $padding;
                $commonReplacer[albumPlaceholder('SLIDE_TABLE')]       = $slide_table;
                $commonReplacer[albumPlaceholder('SLIDE_SIZE')]        = $size;
                $commonReplacer[albumPlaceholder('SLIDE_PADDING')]     = $padding;
                $commonReplacer[albumPlaceholder('POP_UP_WIDTH')]      = $pop_up_width;
                $commonReplacer[albumPlaceholder('POP_UP_HEIGHT')]     = $pop_up_height;
                $commonReplacer[albumPlaceholder('MAX_WIDTH')]         = $max_width;
                $commonReplacer[albumPlaceholder('MAX_HEIGHT')]        = $max_height;
                $commonReplacer[albumPlaceholder('ALBUM_NAVIGATION')]  = $album_navigation;
                $commonReplacer[albumPlaceholder('ALBUM_ANCHOR')]      = urlencode($show);
                $commonReplacer[albumPlaceholder('ALBUM_DIR')]         = $activeModules['Bilderalbum']['directory'];
                $commonReplacer[albumPlaceholder('ALBUM_DESCRIPTION')] = htmlspecialchars($mod_galery_albums[$show]['beschreibung'], ENT_COMPAT, 'ISO-8859-15');

                $album_string = preg_replace(array_keys($commonReplacer), array_values($commonReplacer), $activeModules['Bilderalbum']['album_template']);

                unset($album_description,$slide_table,$album_navigation);
                }
            // zweiter Durchlauf, falls irgendwelche Variablen nicht ersetzt wurden
            $album_string = preg_replace(array_keys($replacer), array_values($replacer), $album_string);
            $album_string = preg_replace(array_keys($commonReplacer), array_values($commonReplacer), $album_string);
            return $album_string;
            $album_start = $album_start_all;
            }  // Ende Show
        }
    }
}

if (!function_exists('getAlbum'))  {
    function getAlbum($show)  {

        global $activeModules, $mod_galery_albums, $db_nr, $db_titel;

        $nl = "\r\n";

        // Modulvariablen
            $quality		    = $activeModules['Bilderalbum']['quality'];
            $satzspiegel	    = $activeModules['Bilderalbum']['satzspiegel'];
            $min_size		    = $activeModules['Bilderalbum']['min_size'];
            $max_height		    = $activeModules['Bilderalbum']['max_height'];
            $album_height   	= $activeModules['Bilderalbum']['album_height'];
            $pop_up_width	    = $activeModules['Bilderalbum']['pop_up_width'];
            $pop_up_height   	= $activeModules['Bilderalbum']['pop_up_height'];
            $slide_frame	    = $activeModules['Bilderalbum']['slide_frame'];
            $padding		    = $activeModules['Bilderalbum']['padding'];
            $dia_padding	    = $activeModules['Bilderalbum']['dia_padding'];
            $overview_format    = $activeModules['Bilderalbum']['overview_format'];
            $display_navigation = $activeModules['Bilderalbum']['display_navigation'];
            $num_images         = $activeModules['Bilderalbum']['num_images'];
            $image_size         = $activeModules['Bilderalbum']['image_size'];
            $album_rows         = $activeModules['Bilderalbum']['album_rows'];
            if (!$db_nr) $db_nr = 1;

        
        // Bilder auslesen
        $query = "SELECT * FROM ".CPO_MOD_GALLERY." WHERE (album = '".addslashes($show)."' AND datei <> '') ORDER BY sort";
        DEBUG(2, $query, __FILE__, __LINE__);  
        $db = new DB;
        $db->query($query);
        if ($db->num_rows()>0) {
            // Spaltenzahl ermitteln
            $cols = $mod_galery_albums[$show]['width'];		
            $bilderzahl = $db->num_rows();
            if ($overview_format == 'table') {
                $zeilen			= $album_rows;
                $tablesize		= $satzspiegel;
                $size			= floor (($satzspiegel - (($cols - 1) * $padding)) / $cols);
                $thumbsize		= floor ($size - (2 * $slide_frame));
                $pics_per_page	= $zeilen * $cols;
                if ($page>=2) $album_start = 1+(($page-1)*$pics_per_page);
                $album_stop		= $album_start + $zeilen * $cols;
                $seiten			= ceil($bilderzahl / $pics_per_page);
            }
            if ($overview_format == 'pics') {
                $thumbsize		= $image_size;
                $seiten			= ceil($bilderzahl / $num_images);
                $pics_per_page	= $num_images;
                if ($page>=2) $album_start = 1+(($page-1)*$pics_per_page);
                $album_stop		= $album_start + $num_images;
            }
        }

        // Platzhalter allgemein
        $commonReplacer = array();
        $commonReplacer[albumPlaceholder('ARTICLE_NR')]        = $db_nr;
        $commonReplacer[albumPlaceholder('SLIDE_PADDING')]     = $padding;
        $commonReplacer[albumPlaceholder('SLIDE_TABLE')]       = $slide_table;
        $commonReplacer[albumPlaceholder('SLIDE_SIZE')]        = $size;
        $commonReplacer[albumPlaceholder('INNER_SLIDE_SIZE')]  = $thumbsize;
        $commonReplacer[albumPlaceholder('SLIDE_PADDING')]     = $padding;
        $commonReplacer[albumPlaceholder('POP_UP_WIDTH')]      = $pop_up_width;
        $commonReplacer[albumPlaceholder('POP_UP_HEIGHT')]     = $pop_up_height;
        $commonReplacer[albumPlaceholder('ALBUM_NAVIGATION')]  = $album_navigation;
        $commonReplacer[albumPlaceholder('ALBUM_ANCHOR')]      = urlencode($show);
        $commonReplacer[albumPlaceholder('ALBUM_DIR')]         = $activeModules['Bilderalbum']['directory'];
        $commonReplacer[albumPlaceholder('ALBUM_DESCRIPTION')] = $mod_galery_albums[$show]['beschreibung'];

        // album-CSS
        $album_css  = preg_replace(array_keys($commonReplacer), array_values($commonReplacer), $activeModules['Bilderalbum']['album_css']);
        $album_back = preg_replace(array_keys($commonReplacer), array_values($commonReplacer), $activeModules['Bilderalbum']['go_back_text']);

        $album_string = $nl.$nl."<!-- ******************************** Start gallery ".$db_nr." *********************************-->".$nl;

        $album_string .= $album_css.$nl;

        $album_string .= '<script type="text/javascript">'.$nl;
        $album_string .= 'var activePage=1;'.$nl;
        $album_string .= 'var activeShow=1;'.$nl;
        $album_string .= 'function albumPage(page, nr)  {'.$nl;
        $album_string .= '    activePage = page;'.$nl;
        $album_string .= '    $("div.albumPage"+nr).hide();'.$nl;
        $album_string .= '    $("#albumPage"+page+"_"+nr).fadeIn();'.$nl;
        $album_string .= '    return false;'.$nl;
        $album_string .= '    }'.$nl;
        $album_string .= 'function slidePage(nr, pic, album)  {'.$nl;
        $album_string .= '    activeShow = nr;'.$nl;
        $album_string .= '    $("#inPage_"+nr).attr("src", "../'.$activeModules['Bilderalbum']['directory'].'/popup.php?pic="+pic+"&from="+album);'.$nl;
        $album_string .= '    $("div.albumPage"+nr).hide();'.$nl;
        $album_string .= '    $("#albumPageX_"+nr).fadeIn();'.$nl;
        $album_string .= '    return false;'.$nl;
        $album_string .= '    }'.$nl;
        // window.open(this.href,'Bilderalbum','width=600,height=500,scrollbars=no'); return false;
        $album_string .= 'function slidePopUp(nr, pic, album)  {'.$nl;
        $album_string .= "    window.open('../".$activeModules['Bilderalbum']['directory']."/popup.php?pic='+pic+'&from='+album ,'Bilderalbum','width=".$pop_up_width.",height=".$pop_up_height.",scrollbars=no');".$nl;
        $album_string .= '    return false;'.$nl;
        $album_string .= '    }'.$nl;
        $album_string .= 'function closeSlidePage(nr)  {'.$nl;
        $album_string .= '    albumPage(activePage, nr);'.$nl;
        $album_string .= '    $("#inPage_"+nr).attr("src", "");'.$nl;
        $album_string .= '    return false;'.$nl;
        $album_string .= '    }'.$nl;
        $album_string .= '$(document).keypress(function(e) { if (e.which == 27) closeSlidePage(activeShow) }); // ESC-Key'.$nl;
        $album_string .= '</script>'.$nl.$nl;

        if ($overview_format == 'table') $album_string .= '<div style="width:'.$satzspiegel.'px;">'.$nl;
        
        $album_string .= '<div id="albumPage1_'.$db_nr.'" class="albumPage'.$db_nr.'">'.getAlbumPage($show, 1).'</div>'.$nl;
        for ($i=2;$i<=$seiten;$i++) {
            $album_string .= '<div id="albumPage'.$i.'_'.$db_nr.'" class="albumPage'.$db_nr.'" style="display:none;">'.getAlbumPage($show, $i).'</div>'.$nl;
        }
        $album_string .= '<div id="albumPageX_'.$db_nr.'" class="albumPage'.$db_nr.'" style="display:none;"><iframe id="inPage_'.$db_nr.'" style="border: none;width:'.$pop_up_width.'px;height:'.$pop_up_height.'px;display:block;" ></iframe>'.$album_back.'</div>'.$nl;

        if ($overview_format == 'table') $album_string .= '</div>';

        $album_string .= $nl.$nl."<!-- ******************************** End gallery ".$db_nr." *********************************-->".$nl.$nl;

        return $album_string;
    }
}