<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

HINWEIS: Die Bildergalerien werden niemals direkt ber eine URL aufgerufen!
Fgen Sie einfach in ein Artikeltemplate einen der SLIDESHOW-Platzhalter ein
und es wird die Galerie benutzt, die den gleichen Titel wie der Artikel trgt.

NOTICE: The galleries can't be shown by using a URL!
Just put a SLIDESHOW placeholder in your article template and the gallery
matching the article title will be shown.

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php');

$pagetype = 'index';
require_once(CPO_BASEDIR.'_include/var_category.php');
require_once(CPO_BASEDIR.'_include/secure.php');

// Seitenausgabe ********************************************************

$cpoRubric['id'] = 1;
$cpoRubric['directory'] = 'mod_gallery';
$cpoRubric['name'] = 'mod_gallery';
$cpoRubricSettings['title'] = __('Picture Gallery / Slideshow') . ' :: ' . __('Preview');

ob_start();
	if (isset($_REQUEST['show']))  {
        echo getAlbum($_REQUEST['show']);
	} elseif (isset($_REQUEST['album_page']))  {
		$_GET['show'] = $_REQUEST['album_page'];
		echo getAlbum($_REQUEST['show']);
	} else {
		echo '<h2>' . __('This is only a preview page, not for frontend use!<br />If you see no slideshow, then you are using this page in a wrong way!') . '</h2>';
	}
    // ein paar Warnmeldungen
    if ($activeModules['Bilderalbum']['usage_message'] == 'yes')  {
        $message[] = __('NOTICE: The galleries can\'t be shown by using a URL! Just put a SLIDESHOW placeholder in your article template and the gallery matching the article title will be shown.');
		$message[] = __('This is only a preview page, not for frontend use!<br />If you see no slideshow, then you are using this page in a wrong way!');
    }
    require(CPO_BASEDIR."_include/message.php");
$showPreview = ob_get_clean();

// header and footer mechanism
if (($cpoRubricSettings['pagetemplate_'.$pagetype]==0 && $activeModules['Bilderalbum']['pagetemplate_index'] == -2) || $activeModules['Bilderalbum']['pagetemplate_index']==0) {
    include(CPO_BASEDIR.$directory.'/loadheaders.php');
    echo $showPreview;
	include(CPO_BASEDIR.$directory.'/loadfooters.php');
    exit;
}

// fetch pagetemplate from database and build page
$pagetemplate = ($activeModules['Bilderalbum']['pagetemplate_index']==-2) ? $cpoRubricSettings['pagetemplate_'.$pagetype] : $activeModules['Bilderalbum']['pagetemplate_index'];

$db = new DB;
$db->query('SELECT pagetemplate FROM '.CPO_PAGETEMPLATES.' '
    .'WHERE id='.(int)$pagetemplate.' '
);
$db->next_record();
$pageTemplate = $db->v('pagetemplate');
$pageTagsPreg = '/<!--\s*page\s*:\s*articles\s*(?!id=)[^>]\s*-->/isU'; // nur der Artikelplatzhalter der aktuellen Rubrik, also OHNE id
$pageTemplate = preg_replace ($pageTagsPreg, $showPreview, $pageTemplate);
require CPO_BASEDIR.'_include/buildpage.inc.php';

?>
