<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Gallery"                                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.3b / January 2014

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php');

// Sprache
$directory = basename(dirname($_SERVER['PHP_SELF'])); 
$translator->addTranslation('slideshow',CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/lang');

// Can I create a file in ./bilder?
$check = is_writable("bilder");
if ($check == false) {
	$message[] = __('The directory <i>bilder</i> is not writable! Please set the propper rights to "write"!');
}

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

// Seitenausgabe ********************************************************

// Header
require(CPO_BASEDIR.'_include/header.php');

// Automatisches Verarbeiten eine Verzeichnisses

$num_to_process = $activeModules['Bilderalbum']['staggered_num'];
$finished = FALSE;
$start_with = (!isset($_GET['start'])) ? 0 : $_GET['start'];

if (!isset($_GET['edit']))  $_GET['edit'] = $_POST['edit'];
$edit = $_GET['edit'];
$album = $_REQUEST['album'];

// **** Verzeichnis verarbeiten *********************************************************************************
if(isset($_POST['process_directory']) || $_GET['mode'] == "staggered")  {
	printPageHeader(
		__('Staggered processing'),
		sprintf(__('In this view you can watch the import process for the slideshow <i>%s</i>.'), $_REQUEST['album']).
		'<br />'.
		__('Dont stop the processing! If the process stops although not all images have been processed you have to reduce the number of images to process per step!'),
        modHelp('application','gallery'),
        true,
        'modules'
	);

	include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/actions_process.inc.php');
	$start_with += $num_to_process;
    if (!$finished)  {
		echo "<script language=\"JavaScript\" type=\"text/javascript\">timerID = window.setTimeout('location.href=\"$PHP_SELF?mode=staggered&cols=$cols&album=".htmlspecialchars($album, ENT_COMPAT, 'ISO-8859-15')."&start=".$start_with."\";',500);</script>";
		$message[] = sprintf(__('Press %s to abort the processing OR WAIT!'), '<a href="javascript:void(0)" onclick="clearTimeout(timerID)">STOP</a>');
	}
}

// **** Bilder/Thumbs umrechnen  *********************************************************************************
if(isset($_GET['recalculate']))  {
	printPageHeader(
		__('Staggered processing'),
		__('In this view you can watch the recalculation process for the slideshows.'),
		'<br />'.
		__('Dont stop the processing! If the process stops although not all images have been processed you have to reduce the number of images to process per step!'),
        modHelp('application','gallery'),
        true,
        'modules'
	);

	include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/actions_process.inc.php');
	$start_with += $num_to_process;
    if (!$finished)  {
		echo "<script language=\"JavaScript\" type=\"text/javascript\">timerID = window.setTimeout('location.href=\"$PHP_SELF?recalculate=".$_GET['recalculate']."&start=$start_with\";',500);</script>";
		$message[] = sprintf(__('Press %s to abort the processing OR WAIT!'), '<a href="javascript:void(0)" onclick="clearTimeout(timerID)">STOP</a>');
	}
}

require(CPO_BASEDIR."_include/message.php");

// Footer
include(CPO_BASEDIR.$activeModules['Bilderalbum']['directory'].'/includes/producer.inc.php');
require(CPO_BASEDIR.'_include/footer.php');

?>